head	1.5;
access;
symbols;
locks
	bilbo:1.5; strict;
comment	@ * @;


1.5
date	2003.09.11.01.59.57;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2003.09.10.18.08.33;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.06.08.15.12.57;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.31.01.25.57;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.22.13.10.00;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.5
log
@*** empty log message ***
@
text
@/***
 .map loading + .b4d loading/saving functions
 + funkce na praci s tokeny
 */
#include "b_map.h"

#ifdef map_named_model //[PASS]
int model_serial;//seriove cislo modelu v mape (aby slo referencovat v sitove hre) [EXT]
#endif//[PASS]

text_token *parse_error=(text_token *)("error"); //specialni konstanta znacici parse error

/** nahraje referenci na texturu(pripadne celou texturu, je-li treba) */
int token_loadtexref(text_token *t,texture **c) {
 char *texname;
 if (!token_loadlstring(t,&texname)) return 0;
 if (!texname || !*texname) {
  *c=0;return 1;//objekt bez textury
 }
 *c=b_loadtexture(texname);
 free(texname);
 return 1;
}

/** nahraje binarni model z tokenu */
int token_loadmodelb(text_token *t,model3d **m2) {
 int i,r,nv;
 model3d *m;
 material *mat;
 texture *tx;
 byte tex_color[4];
 *m2=0;
 //pocty
 r=token_loadintb(t,&nv);
 if (!r) return 0;
 if (!nv) return 1;
 m=malloc0(sizeof(model3d));
 m->nvert=nv;
 r=r && token_loadintb(t,&m->nface);
 r=r && token_loadintb(t,&m->nfacev);
 if (!r) {
  free(m);
  return 0;
 }
 m->vert=malloc1(m->nvert*sizeof(vertex));
 m->facev=malloc1(m->nfacev*sizeof(facecoord));
 m->face=malloc1(m->nface*sizeof(modelface));
 for (i=0;i<m->nvert;i++) {
  r=r && token_loadvectorb(t,&(m->vert[i]));
 }
 for (i=0;i<m->nface;i++) {
  r=r && token_loadvectorb(t,&(m->face[i].normal));
  r=r && token_loadintb(t,&(m->face[i].ncoord));
  r=r && token_loadbinary(t,&tex_color,sizeof(tex_color));
  r=r && token_loadtexref(t,&tx);
  if (r) {
   mat=mat_create(tex_color[0],tex_color[1],tex_color[2],tex_color[3],tx);
   model_material_used(m,m->face[i].m);
   m->face[i].m=mat;
  }
 }
 for (i=0;i<m->nfacev;i++) {
  r=r && token_loadfloatb(t,&(m->facev[i].u));
  r=r && token_loadfloatb(t,&(m->facev[i].v));
  r=r && token_loadintb(t,&(m->facev[i].n));
//  debug_printf("%g %g\n",m->facev[i].u,m->facev[i].v);
 }
 if (!r) {
  free(m->face);
  free(m->vert);
  free(m->facev);
  free(m);
  return 0;
 }
 model_set_materials(m);//nastavi textury jako pouzite
 debug_printf("load vert %d,face %d,facev %d\n",m->nvert,m->nface,m->nfacev);
 *m2=m;
 return 1;
}

/** nacte jeden token zacinajici { a koncici na } , dbaje na uroven vnorenych zavorek */
text_token *token_readobject(text_token *t) {
 int end=1,br=1;
 char *token=NULL;
 text_token *new_t=0;
 token_skip_trash(t);
 if (!t->left) return 0;
 if (!token_beginwith(t,'{')) return parse_error;
 while (t->left>=end) {
  //TODO: pokud to narazi na komentar //, tak tam zavorky { } ignorovat !!!!
  if (t->curr[end]=='{') br++;
  if (t->curr[end]=='}') br--;
  end++;
  if (br==0) {
   token=malloc1(end-1);
   memmove(token,t->curr+1,end-2);
   token[end-2]=0;
   break;
  }
 }
 if (br!=0) return parse_error;
 token_move(t,end);
 token_create_dynamic(new_t,token,end-2);
 return new_t;
}

/** nahraje z tokenu objectlist */
int token_loadobjectlist(text_token *t,objectlist *o) {
 int i,n;
 if (!token_loadintb(t,&n)) return 0;//number of objects
 o->numobj=n;
 o->alocobj=n;
 if (!n) return 1;//zadne objekty
 o->obj=malloc0(n*sizeof(void*));
 for (i=0;i<n;i++) {
  o->obj[i]=malloc1(n*sizeof(object3d));
  if (!token_readobject3d(t,o->obj[i])) return 0;
 }
 return 1;
}

/** nahraje rotaci z tokenu */
int token_loadrotation(text_token *t,rotation *r) {
 return token_loadbinary(t,r,sizeof(rotation));
}

/** nahraje referenci na class(pripadne celou class, je-li treba) */
int token_loadclassref(text_token *t,objectclass **c) {
 char *classname;
 if (!token_loadlstring(t,&classname)) return 0;
 if (!classname || !*classname) {
  *c=0;return 1;//objekt bez classy
 }
 *c=b_loadclass(classname,1);
 free(classname);
 return 1;
 //TODO: po zavolani tohohole je potreba udelat setclass na objekt (zavola mimo jine konstruktor)
}

/** nahraje properties z tokenu */
int token_loadprop(text_token *t,properties **p) {
 char *q;
 properties *r;
 for (;;) {
  if (!token_loadlstring(t,&q)) return 0;
  if (!q) break;//konec seznamu
  r=malloc1(sizeof(properties));
  r->k=q;
  r->next=*p;
  *p=r;
  if (!token_loadlstring(t,&(r->v))) return 0;
 }
 return 1;
}

/** nahraje z tokenu jeden object3d (binarni) */
int token_readobject3d(text_token *t,object3d *o) {
 //position/orientation
 int r=token_loadvectorb(t,&o->head);
 r=r && token_loadvectorb(t,&o->left);
 r=r && token_loadvectorb(t,&o->up);
 r=r && token_loadvectorb(t,&o->p);
 //movement
 r=r && token_loadvectorb(t,&o->d);
 r=r && token_loadvectorb(t,&o->nd);
 //other 
 r=r && token_loadrotation(t,&o->rot);
 r=r && token_loadrotation(t,&o->rotplus);
 r=r && token_loadclassref(t,&o->type);
 r=r && token_loadprop(t,&o->prop);
 //podrazene objekty
 r=r && token_loadobjectlist(t,&o->child);
 //model
 r=r && token_loadmodelb(t,&o->model);
 //features
 r=r && token_loadbinary(t,&o->f,sizeof(o->f));
 return r;
}

/** nacte z tokenu jeden face */
int token_readbrushface(text_token *t,map_brushface *f) {
 int r=token_readvector(t,&(f->v1));
 r=r && token_readvector(t,&(f->v2));
 r=r && token_readvector(t,&(f->v3));
 r=r && (f->tname=token_readstring(t))!=0;
 r=r && token_readfloat(t,&(f->u));
 r=r && token_readfloat(t,&(f->v));
 r=r && token_readfloat(t,&(f->rotation));
 r=r && token_readfloat(t,&(f->scale_x));
 r=r && token_readfloat(t,&(f->scale_y));
 //korekce nesmyslu
 if (f->scale_x==0) f->scale_x=1;
 if (f->scale_y==0) f->scale_y=1;
 //TODO: novy format ma na konci radku jeste tri floaty 0- k cemupak asi jsou?
 token_remove_rest_of_line(t);
 return r;
}

/** halfplane: vraci 1, lezi li bod x na polorovine dane hranicnim bodem h a normalovym vektorem d */
int halfplane(vertex h,vector d,vertex x) {
 v_addf(&x,h,-1);
 return (v_muls(d,x)>=0.0);
}

/** halfplane2: vraci kladne cislo, lezi li bod x lezi li na polorovine dane hranicnim bodem h a normalovym vektorem d,
                nulu pokud lezi na hranici,
                a zaporne cislo pokud v ni nelezi */
int halfplane2(vertex h,vector d,vertex x) {
 bfloat q;
 v_addf(&x,h,-1);
 q=v_muls(d,x);
 return q>0?1:(q<0?-1:0);
}

#define debug_chop(x) /*debug_printf(x " (<%g %g %g>[%g]) of (%d<%g %g %g>-<%g %g %g>%d)with (<%g %g %g>-<%g %g %g>)\n",\
all3d(intersect),a,t->open_v1,all3d(t->v1),all3d(t->v2),t->open_v2,all3d(cutter->v1),all3d(cutter->v2))

// [%3.1f %3.1f %3.1f]
//,all3d(cutter->in),halfplane(cutter->v1,cutter->in,t->v1),halfplane(cutter->v1,cutter->in,t->v2))
/**/
//do nothing (debugovani zde jiz _snad_ skoncilo)

#define RAY_CHOP_DELTA 0.0005 //odchylka pri pruniku primek

/** orizne primku t pomoci primky cutter, vyuzije udaje o pruniku */
void ray_chop(brush_ray *t,brush_ray *cutter,bfloat a,vector intersect) {
//TODO: dosti bugovy kod, vyladit ....
 if (fabs(a)<=RAY_CHOP_DELTA) {//proti zaokrouhlovacim chybam, ty to obcas pekne zmrsi
  a=0;
  intersect=t->v1;
 }
 if (fabs(a-1)<=RAY_CHOP_DELTA) {//proti zaokrouhlovacim chybam, ty to obcas pekne zmrsi
  a=1;
  intersect=t->v2;
 }
 if (a<=0.0) { //a=(-inf..0)
  if (halfplane(cutter->v1,cutter->in,t->v2)) {
   if (t->open_v1) { // useknuti konce primky/poloprimky (prdlouzeni za orig.bod)
 debug_chop("-chop-");
    t->v1=intersect;
    t->p=v_sub(t->v2,t->v1);
    t->open_v1=0;
 debug_chop("RES  >");
   } //else neni co useknout, cela poloprimka/usecka lezi v dobre polorovine
  } else {
   if (t->open_v1) { //useknuti konce primky
 debug_chop("-chop+");
    t->v2=intersect;
    t->v1=v_sub(t->v2,t->p);
    t->open_v2=0;
 debug_chop("RES  >");
   } else { //odseknuti cele primky
 debug_chop("-degen");
    degenerate(t);
   }
  }
 } else if (a>=1.0) { //a=(1..inf)
  if (halfplane(cutter->v1,cutter->in,t->v1)) {
   if (t->open_v2) { // useknuti konce primky/poloprimky (prdlouzeni za orig.bod)
 debug_chop("+chop+");
    t->v2=intersect;
    t->p=v_sub(t->v2,t->v1);
    t->open_v2=0;
 debug_chop("RES  >");
   } //else neni co useknout, cela poloprimka/usecka lezi v dobre polorovine
  } else {
   if (t->open_v2) { //useknuti konce primky
 debug_chop("+chop-");
    t->v1=intersect;
    t->v2=v_plus(t->v1,t->p);
    t->open_v1=0;
 debug_chop("RES  >");
   } else { //odseknuti cele primky
 debug_chop("+degen");
    degenerate(t);
   }
  }
 } else { //a = (0..1) - trefa nekam mezi
  if (halfplane(cutter->v1,cutter->in,t->v2)) {   //odseknout v1
 debug_chop("0chop+");
   t->v1=intersect;
   t->p=v_sub(t->v2,t->v1);
   t->open_v1=0;
 debug_chop("RES  >");
  } else {                                        //odseknout v2
 debug_chop("0chop-");
   t->v2=intersect;
   t->p=v_sub(t->v2,t->v1);
   t->open_v2=0;
 debug_chop("RES  >");
  }
 }
}

/** prida primku do brush face,udela prunik s ostatnimi primkami */
void brush_addray(map_brushface *face,vector b,vector d,vector in) {
 int i,max,r;
 ray_ray_intersect rr;
 brush_ray tr;
 max=face->num_rays;
 //create temp. ray
 tr.v1=b;
 tr.p=d;
 v_sum2(&(tr.v2),b,d);
 tr.open_v1=1;
 tr.open_v2=1;
 tr.in=in;
#define debug_printf2// debug_printf
 for (i=0;i<max;i++) {
  if (degenerated(face->ray[i])) {
   debug_printf2("skipped degen\n");
   continue; //primka zdegenerovana na bod
  }
  r=intersect_ray_ray(face->ray[i].v1,face->ray[i].p,tr.v1,tr.p,&rr);
//  debug_printf("Ray [%g %g %g] +[%g %g %g] vs [%g %g %g]-[%g %g %g] -> [%g %g %g]\n",all3d(b),all3d(d),all3d(face->ray[i].v1),all3d(face->ray[i].v2),all3d(rr.p));
  switch(r) {
   case INTERSECT:case INTERSECT_BACK: //nekde se protinaji
    ray_chop(&tr,&face->ray[i],rr.b,rr.p);
    if (degenerated(tr)) {
     debug_printf2("chopped to nothing\n");
     break; //primka zdegenerovala na bod
    }
    ray_chop(&face->ray[i],&tr,rr.a,rr.p);
    if (degenerated(face->ray[i])) debug_printf2("original chopped to nothing\n");
    break;
   case PARALLEL:   // dve rovnobezky, checknout (in,b) vs (face->ray[i].in,face->ray[i].v1), jinak je to ok
//   debug_printf("brush_addray: PARALLEL (%d) (%g %g %g,%g %g %g) x (%g %g %g,%g %g %g)\n",r,all3d(face->ray[i].v1),all3d(face->ray[i].p),all3d(tr.v1),all3d(tr.p));
    break;
   case IDENTICAL:  // identicke primky, nemelo by se stavat
    debug_printf("brush_addray: IDENTICAL (%d) (%g %g %g,%g %g %g) x (%g %g %g,%g %g %g)\n",r,all3d(face->ray[i].v1),all3d(face->ray[i].p),all3d(tr.v1),all3d(tr.p));
    return;
   default : debug_printf("brush_addray: no intersection (%d) (%g %g %g,%g %g %g) x (%g %g %g,%g %g %g)\n",r,all3d(face->ray[i].v1),all3d(face->ray[i].p),all3d(tr.v1),all3d(tr.p));
  }
 }
 //TODO: nejake trideni by to chtelo, takhle to ma slozitost n^2 (i kdyz to tady zas tak moc nevadi)
 if (degenerated(tr)) return;//zdegenerovane primky nebudou pridany
// debug_printf("      Add Ray %d [%g %g %g] +[%g %g %g]\n",((int)face-9528764)/160+410,all3d(b),all3d(d));
 face->ray[max]=tr;
 face->num_rays++;
}

/** spocte jestli je normala podlaha ci strop (uhel mensi nez 45 stupnu) */
int is_floory(vector n) {
 return n.z*n.z>fabs(n.x*n.y);
}

vector base[18]={ //vektor urcujici 6 ruznych bazi. Pouziva se pro spravne mapovani textur prei nahravani .map formatu 
 { 0, 0, 1}, {1,0,0}, {0,-1, 0},// up
 { 0, 0,-1}, {1,0,0}, {0,-1, 0},// down
 { 1, 0, 0}, {0,1,0}, {0, 0,+1},// west
 {-1, 0, 0}, {0,1,0}, {0, 0,+1},// east
 { 0, 1, 0}, {1,0,0}, {0, 0,+1},// south
 { 0,-1, 0}, {1,0,0}, {0, 0,+1} // north
};

/** zjisti k jakemu bazovemu vektoru ma normala nejblize a najde pro ni X a Y smernice textury. 
algoritmus je kompatiblini se standardnimi quake .map soubory */
void nearest_axis(vector normal, vector *x, vector *y) {
 int ax=0;
 bfloat d,nearest=0;
 int i;
 for (i=0;i<6;i++) {
  d=v_muls(normal,base[i*3]);
  if (d>nearest) {
   nearest=d;
   ax=i;
  }
 }
 *x=base[ax*3+1];
 *y=base[ax*3+2];
}

/** spocte 2d souradnice pro texturu v 3d prostoru. System je kompatibilni s .map formatem v quakovi */
void tex_coord(bfloat *tx,bfloat *ty,vertex v,map_brushface *f) {
 bfloat tex_x,tex_y,x,y;
 bfloat sinv,cosv,n_u,n_v;
 vector2 baset[2];// bazove vektory textury
 int sv,tv,i;
 bfloat rotate=f->rotation;

 tex_x=f->t->mem->head.x;
 tex_y=f->t->mem->head.y;
 
 nearest_axis(f->normal,(vector *)baset+0,(vector *)baset+1); // k jake z 6 os ma rovina nejblize - urceni basovych vektoru textury
 // rotace textury	
 if (rotate<0) rotate+=360;	
 if (rotate==  0) {sinv= 0;cosv= 1;} else
 if (rotate== 90) {sinv= 1;cosv= 0;} else
 if (rotate==180) {sinv= 0;cosv=-1;} else
 if (rotate==270) {sinv=-1;cosv= 0;} else {
  bfloat a=rotate/180.0*pi;
  sinv=sin(a);
  cosv=cos(a);
 }
 //prvni nenulova slozka bazoveho vektoru
 if (baset[0].a[0]) sv=0; else if (baset[0].a[1]) sv=1; else sv=2;
 if (baset[1].a[0]) tv=0; else if (baset[1].a[1]) tv=1; else tv=2;
 //vypocet bazovych vektoru textury							
 for(i=0;i<2;i++){
  n_u=cosv*baset[i].a[sv]-sinv*baset[i].a[tv];
  n_v=sinv*baset[i].a[sv]+cosv*baset[i].a[tv];
  baset[i].a[sv]=n_u;
  baset[i].a[tv]=n_v;
 }
//  debug_printf("<%g %g %g> got <%g %g %g> <%g %g %g>\n",f->normal,baset[0],baset[1]);
//baset[1]*x+baset[2]*y+((baset[1] x baset[2])*z)=real(x,y,z)
 //tohle funguje, protoze: vektory baze jsou ortonormalni (netreba pocitat determinant matice 3x3 nebo neco takoveho)
 x=v_muls(*(vector*)(&(baset[0])),v);
 y=v_muls(*(vector*)(&(baset[1])),v);
//  fatalf("sizeo=%d %d",sizeof(vector),sizeof(vector2));

//TODO: ne vsechny textury jsou spravne posunute. Asi bude nekde chyba.
//TODO: u Q2 je to posunute trochu, u Q3 docela dost
// debug_printf("%g %g    %g %g   <%g %g %g>   %g %g\n",f->u,f->v,x,y,v,tex_x,tex_y);
// getch();
 *tx=((x+f->u)/f->scale_x)/tex_x;
 *ty=((y+f->v)/f->scale_y)/tex_y;
}

/** pozice bodu vzhledem k rovine (nepouzivana funkce)
 Urci jestli bod je pod rovinou (-x), v ni (0), nebo nad ni (+x) */
bfloat point_plane_position(vector v,vector n,vector target) {
 return v_muls(n,v_sub(target,v));
}

/** v pripade, ze ma rovina otoceny normalovy vektor (bohuzel se stava) tak ho prohodi */
void normal_correct(map_brushface *i,map_brushface *j,plane_plane_intersect *is) {
 bfloat r;
 r=halfplane2(is->p,is->in2,j->v1);
 if (fabs(r)<0.0001) r=halfplane2(is->p,is->in2,j->v2);
 if (fabs(r)<0.0001) r=halfplane2(is->p,is->in2,j->v3);
 if (r<-0.0001) {
  debug_printf("flipped j (%g)\n",r);
  v_mul(&(j->normal),-1);
  v_mul(&(is->in2),-1);
 }

 r=halfplane2(is->p,is->in1,i->v1);
 if (fabs(r)<0.0001) r=halfplane2(is->p,is->in1,i->v2);
 if (fabs(r)<0.0001) r=halfplane2(is->p,is->in1,i->v3);
 if (r<-0.0001) {
  debug_printf("flipped i (%g)\n",r);
  v_mul(&(i->normal),-1);
  v_mul(&(is->in1),-1);
 }
}

/** najde dalsi vertex prochazenim primek v brushi
 current - aktualni vertex, bude nahrazen novym
 iray - aktualni primka (index), bude nahrazena novou
 num_rays - velikost pole primek
 ray1 - pole primek, ze ktereho se vybira
 vrati 1 - bod nalezen
 nebo 0 - bod nenalezen
 */

#define min_delta 0.0002 //odchylka tak mala, ze se bere hned
#define max_delta 0.3333 //maximalni pripustna odchylka

int findnextray(int num_rays,brush_ray *ray1,int *iray,vector *current) {
 int j;
 bfloat best_delta=max_delta+min_delta+99999;//maximalni odchylka (na zacatku je to "o chlup vic" nez je pripustne)
 bfloat cdelta;//aktualni odchylka
 int best_j;
 vector best_v;
 for (j=0;j<num_rays;j++) {
  if (j==*iray) continue;
  if (degenerated(ray1[j])) continue;
  if ((cdelta=v_eq_delta(*current,ray1[j].v1))<min_delta) {
   *current=ray1[j].v2;
   *iray=j;
   return 1;
  }
  if (cdelta<best_delta) { 
   best_delta=cdelta;
   best_j=j;
   best_v=ray1[j].v2;
  }
  //debug_printf("%g %g %g neq %g %g %g (%g %g %g)\n",all3d(*current),all3d(ray1[j].v1),all3d(v_sub(*current,ray1[j].v1)));
  if ((cdelta=v_eq_delta(*current,ray1[j].v2))<min_delta) {
   *current=ray1[j].v1;
   *iray=j;
   return 1;
  }
  if (cdelta<best_delta) { 
   best_delta=cdelta;
   best_j=j;
   best_v=ray1[j].v1;
  }
  //debug_printf("%g %g %g neq %g %g %g (%g %g %g)\n",all3d(*current),all3d(ray1[j].v2),all3d(v_sub(*current,ray1[j].v2)));
 }
 if (best_delta<max_delta) { 
  *iray=best_j;
  *current=best_v;
  return 1;
 }
 debug_printf("pruser. Nelze slepit (delta=%g)\n",best_delta);
 return 0;
 //TODO: zkusit najit podobny vertex v ostatnich facech a nahradit ho (jinak muzou vznikat skviry)
}

//debugovaci veci - v release nebudou   
//TODO: prvnich par radek (common/*) je jen hack pro nahravani testovacich levelu z quaka 3: to tu ve finalni verzi nebude .....
#define debug_brushfaces_to_model1    if (eqi("common/clip",face[i].t->name)) alpha=0;\
    if (eqi("common/weapclip",face[i].t->name)) alpha=0;\
    if (eqi("common/caulk",face[i].t->name)) alpha=0;\
    if (eqi("common/hint",face[i].t->name)) alpha=0;\
    if (eqi("common/trigger",face[i].t->name)) alpha=0;\
    if (eqi("common/clusterportal",face[i].t->name)) alpha=0;\
    if (eqi("common/donotenter",face[i].t->name)) alpha=0;\
    if (eqi("e3u3/wndow1_2",face[i].t->name)) alpha=200;\
    if (alpha>1000) {\
    model_face_begin_id(tmp,64,64,255,128,0);\
    model_vertexvs(tmp,0,0,face[i].v1,mapscale);\
    model_vertexvs(tmp,0,0,face[i].v2,mapscale);\
    model_face_end(tmp);\
    model_face_begin_id(tmp,255,64,64,128,0);\
    model_vertexvs(tmp,0,0,face[i].v1,mapscale);\
    model_vertexvs(tmp,0,0,face[i].v3,mapscale);\
    model_face_end(tmp);\
    model_face_begin_id(tmp,64,255,64,128,0);\
    model_vertexvs(tmp,0,0,face[i].v1,mapscale);\
    model_vertexvs(tmp,0,0,v_plusf(face[i].v1,face[i].normal,10),mapscale);\
    model_face_end(tmp);}

/** prida jeden brush do modelu (nekolik faces) */
void brushfaces_to_model(int facenum,map_brushface *face,tmpmodel *tmp) {
 vertex **vf;//vertexy facu
 int *vn;//number of vertexes
 int i,j,r;
 vertex average={0,0,0};//prumer (vertex uvnitr)
 int average_n=0;//pocet vertexu v prumeru
 plane_plane_intersect is;
 vf=malloc1(facenum*sizeof(void *));
 vn=malloc0(facenum*sizeof(int));
 for (i=0;i<facenum;i++) { // nahraje vsechny textury, predpripravi kazdy face
  vf[i]=malloc1(facenum*sizeof(vertex)); //vic nez facenum vertexu v kazdem brushi nikdy byt nemuze
  face[i].t=b_loadtexture(face[i].tname);
  v_mulv2(&face[i].normal,v_sub(face[i].v2,face[i].v1),v_sub(face[i].v3,face[i].v1));//calculate normal (normalized)
  normalize(&(face[i].normal));
  face[i].degenerated=0;
  face[i].ray=malloc1(sizeof(brush_ray)*facenum);//vic nez facenum primek v kazdem brushi nikdy byt nemuze
  face[i].num_rays=0;
 }
 for (i=0;i<facenum;i++) {//spocita bod, ktery je zarucene vevnitr telesa
  //TODO: uz asi ten bod neni potreba
  v_add(&average,face[i].v1);
  v_add(&average,face[i].v2);
  v_add(&average,face[i].v3);
  average_n+=3;
 }
 v_mul(&average,(1.0/average_n));
 for (i=0;i<facenum;i++) { //pro kazdy face
//  debug_printf("x=%d y=%d %s\n",tx,ty, face[i].t->name);
/*  debug_printf("Face: <%g,%g,%g> <%g,%g,%g> <%g,%g,%g> [%g,%g] %g %s sc=%g,%g\n",
   all3d(face[i].v1),all3d(face[i].v2),all3d(face[i].v3),
   (double)face[i].u,(double)face[i].v,(double)face[i].rotation,face[i].tname,(double)face[i].scale_x,(double)face[i].scale_y);/**/
  for (j=0;j<i;j++) {
   if (face[j].degenerated) continue;
   //TODO: misto intersect plane_plane zkusit intersect tri planes pres cramerovo pravidlo
   r=intersect_plane_plane(face[i].v1,face[i].normal,face[j].v1,face[j].normal,&is);
//   normal_correct(face+i,face+j,&is);
   switch (r) {
    case IDENTICAL:debug_printf("brushfaces_to_model: Duplicate plane (%d)!\n",j);break;
    case NO_INTERSECT:break;//rovnobezne
    case INTERSECT:
     nice_vector(&is.d);
     brush_addray(&(face[i]),is.p,is.d,is.in1);
     brush_addray(&(face[j]),is.p,is.d,is.in2);
     break;
    default:fatalf("unhandled exception: brushfaces_to_model (intersect_plane_plane returned %d)",r);
   }
  }
 }
 for (i=0;i<facenum;i++) { 
//  debug_printf("face %s\n",face[i].t->name);
  for (j=0;j<face[i].num_rays;j++) {
   if (degenerated(face[i].ray[j])) {
    debug_printf("Degenerated: %d/%d\n",i,j);
   } else if (face[i].ray[j].open_v1 || face[i].ray[j].open_v2) {
    debug_printf("Unclosed:    %d/%d\n",i,j);
    face[i].degenerated=1;
   }// else debug_printf("OK:          %d/%d",i,j);
//   debug_printf("%s [%g %g %g],[%g %g %g] %s\n",face[i].ray[j].open_v1?"...":"<",all3d(face[i].ray[j].v1),all3d(face[i].ray[j].v2),face[i].ray[j].open_v2?"...":">");
  }
  if (!face[i].degenerated) {
   vertex current,first;
   int iray,nray=face[i].num_rays;
   brush_ray *ray1;
   bfloat tx,ty;
   //1. primka: ted dat jen ty dalsi
   iray=0;
   ray1=face[i].ray;//pointer pro rychlejsi (a prehlednejsi) pristup
   while (degenerated(ray1[iray])) {
    iray++;nray--;
    if (nray<3) break;
   }
   if (nray>=3) {
    int cw;
    byte alpha;
    alpha=255;
    debug_brushfaces_to_model1;
    model_face_begin_id(tmp,255,255,255,alpha,face[i].t);//TODO: nejak tam propasovat barvy do .map formatu
    cw=v_eq_n(v_mulv(ray1[iray].p,ray1[iray].in),face[i].normal);
    if (cw) first=ray1[iray].v1; else first=ray1[iray].v2;
    tex_coord(&tx,&ty,first,face+i);
 //TODO: first: zkusit najit podobny vertex v predeslych facech a poslat ho misto nej (jinak muzou vznikat skviry)
    model_vertexvs(tmp,tx,ty,first,mapscale);
  //TODO: souradnice textur - jsou trochu mimo, obcas
    if (cw) current=ray1[iray].v2; else current=ray1[iray].v1;
    while (!v_eq(current,first)) {
     tex_coord(&tx,&ty,current,face+i);
   //TODO: current: zkusit najit podobny vertex v predeslych facech a poslat ho misto nej (jinak muzou vznikat skviry)
     model_vertexvs(tmp,tx,ty,current,mapscale);
     if (!findnextray(face[i].num_rays,ray1,&iray,&current)) {
      debug_printf("pruser. Nelze slepit (face %d)\n",i);

//TODO: na mapach, kde nejsou brushe v uhlech 90 stupnu se to obcas mrvi (asi zaokrouhlovaci chyby)
//TODO: v kuchyni skoro ok, jen par chybejicich brushu, ale mapy z q3 jsou dost priserne

      break;
//TODO: TOHLE JE HOOOODNE VELKY PROBLEM. Je tam nekde problem se zaokrouhlovanim, takze to bude chtit resit ....
//(nekde v tech intersections)

      fatalf("pruser. Nelze slepit");
     }
    }
    //TODO: nejake trideni by to chtelo, takhle to ma slozitost n^2 (i kdyz to tady zas tak moc nevadi, neb N je obvykle tak 4, malokdy vice nez 8)
    model_face_end(tmp);//,face[i].normal);
   } else {
    debug_printf("not enough edges (%d, only %d edges)!\n",i,nray);
   }
  } else {
   debug_printf("brushfaces_to_model: Degenerate face (%d)!\n",i);
  }
  free(face[i].ray);
 }
 for (i=0;i<facenum;i++) free(vf[i]);
 free(vf);
 free(vn);
}

/** nacte vektor z retezce */
vector getvector(const char *param) {
 float f[3]; 
 vector v0={0,0,0};
 if (sscanf(param,"%f %f %f",f+0,f+1,f+2)<3)
 if (sscanf(param,"%f , %f , %f",f+0,f+1,f+2)<3) return v0;
 v0.x=f[0];
 v0.y=f[1];
 v0.z=f[2];
 return v0;
}

#pragma warning(disable : 4701) // local variable may be used without having been initialized
/** rozparsuje token, prida do worldspawnu a pak ho releasne z pameti (ten token, ne worldspawn)*/
void token_parse_map(text_token *t,worldspawn *w,int maketemps) {
 properties *p,*q=0;
 text_token *brush;
 char *classname=0;
#ifdef map_named_model
 char tmpmodelname[20];
#endif
 map_brushface *face=0;
 int i,facenum=0,facemax=0,isws;
 object3d *o;
 model3d **m;// do ktereho modelu se bude pridavat
 tmpmodel *tmp;
 vector origin={0,0,0};
 while_(p=token_readprop(t)) {// alespon classname byt musi
  if (eqi(p->k,"classname")) {//classname je specialni
   classname=p->v;
   free(p->k);
   free(p);
   continue;
  }
  if (eqi(p->k,"origin")) {//origin je specialni: pozice objektu
   origin=getvector(p->v);
   origin.x*=mapscale;
   origin.y*=mapscale;
   origin.z*=mapscale;
   free(p->k);
   free(p);
   continue;
  }
  p->next=q;
  q=p;
  debug_printf0("Property: %s = %s\n",p->k,p->v);
 }
 if (!classname) { //objekt bez classname - fatalni chyba!
  //classname=strdup("func_wall");//nema classname -> bude to zed
  debug_printf("token_parse_map: No classname at byte %d\n",(t->curr-t->begin));
  fatal_loading_error=1; //fatal error
  freetoken(t);
  return;
 }
 debug_printf0("Classname = %s\n",classname);
 isws=eqi(classname,"worldspawn");
 if (isws) {
  w->prop=q;
  m=&(w->m);
  debug_printf0("creating worldspawn\n");
 } else {
  o=world_add_empty_object(w);
  o->prop=q;
  o->p=origin;
  m=&(o->model);
 }
 //TODO: nektery textury tam zustanou (asi ty od tech objektu)
 tmp=model_begin();
 while_(brush=token_readobject(t)) {// pocet brushu muze byt i nula (u objektu napriklad)
  if (brush==parse_error) {
   debug_printf("token_parse_map: Parse error at byte %d\n",(t->curr-t->begin));
   fatal_loading_error=1; //fatal error
   model_free(tmp);
   freetoken(t);
   free(classname);
   return;
  }
  if (!facemax) {
   facemax=4;
   face=malloc1(sizeof(map_brushface)*facemax);
  }
  while (token_readbrushface(brush,&(face[facenum]))) {
   facenum++;//read all faces from brush
   if (facenum>=facemax) {
    facemax*=2;
    face=realloc1(face,sizeof(map_brushface)*facemax);
   }
  }
  brushfaces_to_model(facenum,face,tmp);//convert faces to vertexes/edges/surfaces
  facenum=0;
  freetoken(brush);
 }
 if (face) free(face);
 for (i=0;i<tmp->numvert;i++) tmp->v[i]=v_sub(tmp->v[i],origin);
 if (tmp->numvert>0 || (m==&w->m)) *m=model_end(tmp);//generovani finalniho modelu, je-li z ceho
 if (tmp->numvert>0 && (m!=&w->m)) { //pokud neni worldmodel a neni prazdny
  if (!(o->p.x && o->p.y && o->p.z)) { //pokud neni nastaven origin
   o->p.x+=(((*m)->abox.hi.x-(*m)->abox.lo.x)/2+(*m)->abox.lo.x);
   o->p.y+=(((*m)->abox.hi.y-(*m)->abox.lo.y)/2+(*m)->abox.lo.y);
   o->p.z+=(((*m)->abox.hi.z-(*m)->abox.lo.z)/2+(*m)->abox.lo.z);
   abox_move_v(&((*m)->abox),v_negv(o->p));//posun abox tak, aby byla symetricka a nastav origin doprostred aboxu
   for (i=0;i<(*m)->nvert;i++) (*m)->vert[i]=v_sub((*m)->vert[i],o->p);
  }
  #ifdef map_named_model
  if (maketemps) { //nahrava-li se hlavni mapa
   model_serial++;
   _snprintf(tmpmodelname,sizeof(tmpmodelname),":%d",model_serial);
   model_addtomanager(*m,tmpmodelname)->refcount=0x7fffffff;//2 by stacilo ....
  }
  #else
  unused(maketemps);
  #endif
 }
 //pro worldspawn se generuje i prazdny model (aby to nesletelo), i kdyz tady prazdny model celkem postrada smysl
 model_free(tmp);
 freetoken(t);
 if (!isws) class_set(o,classname);//class se nastavuje az kdyz je nahrany model a vsechno ...
 free(classname);
}
#pragma warning(default : 4701) // local variable may be used without having been initialized

/** ulozi odkaz na objectclass (jmeno) do souboru (buffer) */
void wstream_saveclassref(filebuffer *f,objectclass *c) {
 if (!c) {
  wstream_savelstring(f,"");
 } else {
  wstream_savelstring(f,c->classname);
 }
}

/** ulozi odkaz na texturu (jmeno) do souboru (buffer) */
void wstream_savetexref(filebuffer *f,texture *t) {
 if ((!t) || (!t->name)) {
  wstream_savelstring(f,"");
 } else {
  wstream_savelstring(f,t->name);
 }
}

/** ulozi properties do souboru (buffer) */
void wstream_saveprop(filebuffer *f,properties *p) {
 while (p) {
  wstream_savelstring(f,p->k);
  wstream_savelstring(f,p->v);
  p=p->next;
 }
 wstream_saveint(f,-1);//terminator
}

/** ulozi rotation do souboru (buffer) */
void wstream_saverotation(filebuffer *f,rotation *r) {
 wstream_save(f,r,sizeof(rotation));//struktura neni jasna, ale ulozit lze :o)
}

/** ulozi model do souboru (buffer) */
void wstream_savemodel(filebuffer *f,model3d *m) {
 int i;
 if (!m) {//NULL model
  wstream_saveint(f,0);
  return;
 // fatal("wstream_savemodel: no model to save");
 }
 //pocty
 wstream_saveint(f,m->nvert);
 wstream_saveint(f,m->nface);
 wstream_saveint(f,m->nfacev);
 for (i=0;i<m->nvert;i++) {
  wstream_savevector(f,m->vert[i]);
 }
 for (i=0;i<m->nface;i++) {
  wstream_savevector(f,m->face[i].normal);
  wstream_saveint(f,m->face[i].ncoord);
  //todo: save material, not texture
  wstream_save(f,m->face[i].m->color,sizeof(m->face[i].m->color));
  wstream_savetexref(f,m->face[i].m->tex);
 }
 for (i=0;i<m->nfacev;i++) {
  wstream_savefloat(f,m->facev[i].u);
  wstream_savefloat(f,m->facev[i].v);
  wstream_saveint(f,m->facev[i].n);
 }
 debug_printf("save vert %d,face %d,facev %d\n",m->nvert,m->nface,m->nfacev);
}

/** ulozi object do souboru (buffer) */
void wstream_saveobject(filebuffer *f,object3d *o) {
 //position/orientation
 wstream_savevector(f,o->head);
 wstream_savevector(f,o->left);
 wstream_savevector(f,o->up);
 wstream_savevector(f,o->p);
 //movement
 wstream_savevector(f,o->d);
 wstream_savevector(f,o->nd);
 //other 
 wstream_saverotation(f,&o->rot);
 wstream_saverotation(f,&o->rotplus);
 wstream_saveclassref(f,o->type);
 wstream_saveprop(f,o->prop);
 //podrazene objekty
 wstream_saveobjectlist(f,&o->child);
 //model
 wstream_savemodel(f,o->model);
 //features
 wstream_save(f,&o->f,sizeof(o->f));
}

/** ulozi objectlist (vsechny objekty v nem + jaho delku do souboru (buffer) */
void wstream_saveobjectlist(filebuffer *f,objectlist *o) {
 int i,n;
 n=o->numobj;
 wstream_saveint(f,n);
 for (i=0;i<n;i++) {
  wstream_saveobject(f,o->obj[i]);
 }
}

#ifdef map_named_model //[PASS]

char fromc,toc;//prejmenovavani modelu

/** docasne modely nastavi refcount na 1 */
void _model_free_temporaries(const char *name,void *m) {
 if (name[0]==fromc) {
  debug_printf("unloading tmp model %s\n",name);
  ((model *)m)->refcount=1;
 }
 unused(m);
}

/** docasne modely nastavi refcount na 1 */
void _model_rename_temporaries(char *name,void *m) {
 if (name[0]==fromc) name[0]=toc;
 unused(m);
}

/** uvolni z pameti vsechny modely co maji na zacatku jmena ":" - docasne modely */
void model_rename_temporaries(char from, char to) {
 fromc=from;
 toc=to;
 debug_printf("rename models %c -> %c\n",from,to);
 tree_foreach(model_tree,_model_rename_temporaries);//refcount na 1
}

/** uvolni z pameti vsechny modely co maji na zacatku jmena ":" - docasne modely */
void model_free_temporaries(char from) {
 char name[16];
 int i;
 fromc=from;
 debug_printf("unload models '%c*' (tmp models)\n",fromc);
 tree_foreach(model_tree,_model_free_temporaries);//refcount na 1
 for (i=0;i<=model_serial;i++) { // a vsechny ted zlikvidovat
  sprintf(name,"%c%d",fromc,i);
  debug_printf("%s -> off\n",name);
  b_unloadmodel_r(name);
 }
 debug_printf("bug\n");
 tree_foreach(model_tree,_model_free_temporaries);//refcount na 1
 debug_printf("bug\n");
}

#endif //[PASS]

/** nahraje mapu v .map formatu do worldspawnu
maketemps: ma-li vytvaret temporary modely */
worldspawn *loadmap(const char *name,int maketemps) {
 text_token t;
 text_token *token;
 worldspawn *w=world_empty(default_maxobj);
 fatal_loading_error=0;
 t.left=fs_loadfile((void **)(&(t.begin)),name);
 if (!t.begin) return 0;// file IO error
 debug_printf0("Map loaded: %d bytes\n",t.left);
#ifdef map_named_model
 if (maketemps) {
//  model_free_temporaries();
  model_serial=0;
 }
#endif
 t.curr=t.begin;
 while_(token=token_readobject(&t)) {
  if (token==parse_error) {
   debug_printf("loadmap: Parse error at byte %d\n",(t.curr-t.begin));
   free(t.begin);
   freeworld(w);
#ifdef map_named_model
   model_free_temporaries(':');//tmp modely pryc
#endif
//   fatalf("Loading of map %s failed!");
   //TODO: aktualni mapa je neplatna, takze to musi quitnout
   //TODO: lepsi by bylo aktualni mapu v pameti zrusit a hodit hrace do menu
   return 0;
  }
  token_parse_map(token,w,maketemps);
 }
 free(t.begin);
 if (fatal_loading_error) {
//  fatalf("Loading of map %s failed!");
  //TODO: aktualni mapa je neplatna, takze to musi quitnout
  //TODO: lepsi by bylo aktualni mapu v pameti zrusit a hodit hrace do menu
  debug_printf("loadmap: fatal_loading error set\n");
  freeworld(w);
#ifdef map_named_model
  model_free_temporaries(':');//tmp modely pryc
#endif
  return 0;
 }
 return w;
}

/** nahraje model ve formatu .map (neni to nejlepsi format na ukladani modelu, ale taky to tak lze delat)*/
model3d *model_map_load(const char *name) {
 worldspawn *w=loadmap(name,0);
 model3d *m;
 debug_printf0("model_map_load: world=%d\n",w);
 if (!w) return 0;
 m=w->m;
 w->m=0;
 free(w);
 debug_printf0("model_map_load: model=%d\n",m);
 return m;
}


/** ulozi mapu z worldspawnu do vlastniho formatu b4d */
int saveworld(worldspawn *w,const char *name) {
 filebuffer *f;
 exist_or_returni(w,"saveworld(worldspawn)",-1);
 f=wstream_open2(datadir "/",name);
 exist_or_returni(f,"saveworld(filebuffer)",-1);
 wstream_saveint(f,WORLD_ID);
 debug_printf("pos=%d\n",f->bytes);
 wstream_saveobjectlist(f,&w->obj);
 debug_printf("pos=%d\n",f->bytes);
 wstream_saveprop(f,w->prop);
 debug_printf("pos=%d\n",f->bytes);
 wstream_savemodel(f,w->m);
 debug_printf("pos=%d\n",f->bytes);
 wstream_close(f);
 return 0;
}

/** nahraje mapu ve formatu b4d do worldspawnu */
worldspawn *loadworld(const char *name) {
 worldspawn *w=0;
 text_token t;
 char *data;
 int len=loadfile((void **)(&data),name);
 int i,n;
 int ok=0;
 fatal_loading_error=0;
 if (!len) return NULL;
 t.left=len;
 t.curr=t.begin=data;
 debug_printf("something loaded (world)\n");
 for (;;){
  if (!token_loadintb(&t,&i)) break;//world id
  if (i!=WORLD_ID) break;
 debug_printf("pos=%d\n",t.curr-t.begin);
  debug_printf("something loaded (good world)\n");
  if (!token_loadintb(&t,&n)) break;//number of objects
  w=world_empty(n);
  for (i=0;i<n;i++) {
   if (!token_readobject3d(&t,world_add_empty_object(w))) break;
  }
 debug_printf("pos=%d\n",t.curr-t.begin);
  if (!token_loadprop(&t,&w->prop)) break;
 debug_printf("pos=%d\n",t.curr-t.begin);
  if (!token_loadmodelb(&t,&w->m)) break;
 debug_printf("pos=%d\n",t.curr-t.begin);
  ok=1;
  break;
 }
 free(data);
 if (fatal_loading_error) ok=0;
 if (!ok) {
 //if unsuccessful reading, free world & return error
  debug_printf("loadworld: unsuccesful reading: maybe fatal_loading error set\n");
  freeworld(w);
  return 0;
 }
 return w;
}

char *current_map_name=NULL;//aktualni mapa [EXT]

/** nahraje mapu z disku, ze spravneho adresare*/
worldspawn *fs_loadmap(const char* param,int maketemps) {
 //TODO: loadnout nejdriv .b4d potom .map
 //TODO: checknout b4d load/save - asi tam je zastaraly format
 char map[257];
 map[256]=0;
 _snprintf(map,sizeof(map)-1,"%s/%s.map",mapdir,param);
 if (current_map_name) free(current_map_name);
 current_map_name=strdup(param);
 return loadmap(map,maketemps);
}
@


1.4
log
@*** empty log message ***
@
text
@d752 2
@


1.3
log
@*** empty log message ***
@
text
@d7 4
d657 1
a657 1
void token_parse_map(text_token *t,worldspawn *w) {
d661 3
d746 7
d858 49
a906 2
/** nahraje mapu v .map formatu do worldspawnu */
worldspawn *loadmap(const char *name) {
d914 6
d926 6
d934 1
a934 1
  token_parse_map(token,w);
d938 3
d943 3
d953 1
a953 1
 worldspawn *w=loadmap(name);
d1023 14
@


1.2
log
@*** empty log message ***
@
text
@a102 2
int token_readobject3d(text_token *t,object3d *o);//forward

a809 2

void wstream_saveobjectlist(filebuffer *f,objectlist *o);//forward
@


1.1
log
@Initial revision
@
text
@d854 1
a854 1
 t.left=fs_loadfile(&(t.begin),name);
d913 1
a913 1
 int len=loadfile(&data,name);
@
