head	1.4;
access;
symbols;
locks
	bilbo:1.4; strict;
comment	@ * @;


1.4
date	2003.05.19.01.47.01;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.05.12.00.57.26;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.10.18.58.47;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.10.13.50.12;	author bilbo;	state Exp;
branches;
next	;


desc
@model loaders
@


1.4
log
@*** empty log message ***
@
text
@/*** Nahravani ruznych typu modelu ze souboru */

//TODO: udelat
/*
model3d *ase_load(const char *name) {
 open into token
 create tmpmodel
 parse data -> addmodel/loadtexture ...
 finalize model
 free tmp data
}
*/

//forward
text_token token_create(void *source,int size);
char *token_readline(text_token *t);
int token_readkv_sep(text_token *t,char **key,char **value,char separator);
int token_readint(text_token *t,int *i); 
int token_readfloat(text_token *t,bfloat *f);
int token_readplainvector(text_token *t,vector *v);
texture *b_loadtexture(char *name);

//TODO: material manager, material list (aby byl prehled o anonymnich materialech)
//TODO: predelat na mnoha mistech textury do materialu

/** nahrani modelu ve formatu milkshapa ascii */
model3d *model_txt_load(const char *name) {
 int len,num_meshes=0,num_vectors,num_tris,num_normals,num_materials=0,i,j,k,mat_i,dummy,vert_offset=0;
 char *data=0,*key=0,*value=0,*cmap=0,*amap=0;
 text_token t,*tp=&t;
 tmpmodel *m=0; 
 model3d *mf=0;
 bfloat *uv=0;//u,v souradnice
 bfloat x,y,z;
 vector *normal=0;//normaly
 int *tri=0;
 material **mats=0;//struktura s ocislovanymi materialy
 texture *tex=0;

 debug_printf0("model_txt_load: loading file %s\n",name);
 len=fs_loadfile(&data,name);
 if (!data) return 0;
 debug_printf0("model_txt_load: loaded data\n");
 t=token_create(data,len);
 while (token_readkv_sep(tp,&key,&value,':')) {
  if (eqi(key,"meshes")) {
   num_meshes=atoi(value);
   free(key);
   break;//meshes number, ignore rest
  }
  free(key);
 }
 if (num_meshes<1) goto fatal;//soubor je vicemene prazdny
 debug_printf0("model_txt_load: loading mesh(es): %d\n",num_meshes);
 m=model_begin();
 for(j=0;j<num_meshes;j++) {
  debug_printf0("model_txt_load: loading mesh: %d\n",j);
  free(token_readqstring(tp));// mesh: name
  token_readint(tp,&dummy);// flags
  token_readint(tp,&mat_i);// material_index
  //nacteni vertexu
  if (!token_readint(tp,&num_vectors)) goto fatal;//num of vertices
  if (num_vectors<0) goto fatal;
  if (num_vectors==0) { //prazdny objekt - nektere modely ho tam maji - zvlastni ...
   int r= token_readint(tp,&dummy) && (dummy==0);// num normals ()
   r=r && token_readint(tp,&dummy) && (dummy==0);// num faces
   if (r) continue; else goto fatal;
  }
  if (uv) free(uv);
  uv=malloc1(2*sizeof(bfloat)*num_vectors);
  for (i=0;i<num_vectors;i++) { //for each vertex
   if(token_readint(tp,&dummy)//flags
   && token_readfloat(tp,&x)
   && token_readfloat(tp,&y)
   && token_readfloat(tp,&z)
   && token_readfloat(tp,&uv[i*2])
   && token_readfloat(tp,&uv[i*2+1])
   && token_readint(tp,&dummy)//bone index
   ) model_addvertex(m,x,y,z,0); else goto fatal;
  }
  debug_printf0("model_txt_load: vertexes loaded (%d)\n",num_vectors);
  //nacteni normalovych vektoru
  if (!token_readint(tp,&num_normals)) goto fatal;//num of normals
  if (num_normals<1) goto fatal;//zadne normaly
  if (normal) free(normal);
  normal=malloc1(sizeof(vector)*num_normals);
  for (i=0;i<num_normals;i++) { //for each vertex
   if(!token_readplainvector(tp,normal+i)) goto fatal;
  }
  debug_printf0("model_txt_load: normals loaded (%d)\n",num_normals);
  //nacteni trianglu
  if (!token_readint(tp,&num_tris)) goto fatal;//num of tris
  if (num_tris<1) goto fatal;//zadne facy
  if (tri) free(tri);
  tri=malloc1(4*sizeof(int)*num_tris);
  for (i=0;i<num_tris;i++) { //for each tri
   if(token_readint(tp,&dummy)//flags
   && token_readint(tp,&tri[i*4])//vertex index 1
   && token_readint(tp,&tri[i*4+1])//vertex index 2
   && token_readint(tp,&tri[i*4+2])//vertex index 3
   && token_readint(tp,&tri[i*4+3])//normal index 1
   && token_readint(tp,&dummy)//normal index 3
   && token_readint(tp,&dummy)//normal index 2
   && token_readint(tp,&dummy)//smoothing group
   ) {
    for(k=0;k<3;k++) tri[i*4+k]+=vert_offset;// vyssi modely maj vetsi indexy vertexu, nutno premapovat
   } else goto fatal;
  }
  debug_printf0("model_txt_load: loaded tris: %d\n",num_tris);
  //end of reading one mesh, now insert into model
  for (i=0;i<num_tris;i++) { //for each tri (face)
   model_face_begin_mat(m,NULL);//vlozeno bez materialu
   m->f[m->numface-1].m=(material *)mat_i;//takhle natvrdo to tam davam protoze pointery na material jeste nemam. Pozdeji vsechny cisla materialu nahradim spravnymi pointery
   for(k=2;k>=0;k--) { //pridat vertexy 
    int num=tri[i*4+k];
    if (num-vert_offset>=num_vectors || num-vert_offset<0) {
     debug_printf("model_txt_load: bad vertex number: %d at byte offset %d (face %d)\n",num,t.curr-t.begin,i);
     goto fatal;
    }
    model_vertex_num(m,uv[(num-vert_offset)*2],uv[(num-vert_offset)*2+1],num);
   }
   if (tri[i*4+3]>=num_normals || tri[i*4+3]<0) {
    debug_printf("model_txt_load: bad normal number: %d at byte offset %d (face %d)\n",tri[i*4+3],t.curr-t.begin,i);
    goto fatal;
   }
   model_face_end_v(m,normal[tri[i*4+3]]);
  }  
  vert_offset+=num_vectors;
 } //end of reading meshes 
 debug_printf0("model_txt_load: going to load materials\n",num_materials);
 while (token_readkv_sep(tp,&key,&value,':')) {
  if (eqi(key,"materials")) {
   num_materials=atoi(value);
   free(key);
   break;//materials number, ignore rest
  }
  free(key);
 }
 if (num_materials<1) goto fatal;//nejsou materialy! mozna by to slo resit jinak, ale stejne je to vadny soubor, takze co ....
 debug_printf0("model_txt_load: loading material(s): %d\n",num_materials);
 mats=malloc1(sizeof(material)*num_materials);
 for (j=0;j<num_materials;j++) {
  vector ambient,diffuse,specular,emissive;
  bfloat ambient_a,diffuse_a,specular_a,emissive_a,shiny,alpha;
  int r;
  if ((key=token_readqstring(tp))==NULL) goto fatal;
     r=token_readplainvector(tp,&ambient);
  r=r && token_readfloat(tp,&ambient_a);
  r=r && token_readplainvector(tp,&diffuse);
  r=r && token_readfloat(tp,&diffuse_a);
  r=r && token_readplainvector(tp,&specular);
  r=r && token_readfloat(tp,&specular_a);
  r=r && token_readplainvector(tp,&emissive);
  r=r && token_readfloat(tp,&emissive_a);
  r=r && token_readfloat(tp,&shiny);
  r=r && token_readfloat(tp,&alpha);
  if (!r) {
   free(key);
   goto fatal;
  }
  if ((cmap=token_readqstring(tp))==NULL) goto fatal;
  if ((amap=token_readqstring(tp))==NULL) goto fatal;
  if (!cmap || !cmap[0]) tex=0; else tex=b_loadtexture(cmap);
  mats[j]=mat_create((byte)(diffuse.x*255),(byte)(diffuse.y*255),(byte)(diffuse.z*255),(byte)(alpha*255),tex);
#define setv3(_x,_y) _x[0]=(_y).x;_x[1]=(_y).y;_x[2]=(_y).z
  setv3(mats[j]->emission,emissive);
  setv3(mats[j]->ambient,ambient);
  setv3(mats[j]->diffuse,diffuse);
  setv3(mats[j]->specular,specular);
  mats[j]->shininess=shiny;
  mats[j]->ref=1;
  mats[j]->name=key;//nemusi to tu bejt, navic nazev nebude asi unikatni
  debug_printf("Material: %d: mat=%s, tex=%s rgba=%d %d %d %d\n",j,mats[j]->name,(mats[j]->tex)?mats[j]->tex->name:"--",mats[j]->color[0],mats[j]->color[1],mats[j]->color[2],mats[j]->color[3]);
  free(cmap);cmap=0;
  free(amap);amap=0;
 }
 debug_printf0("model_txt_load: %d materials loaded\n",num_materials);
 for (j=0;j<m->numface;j++) { // v kazdem facu replacnout material
  if ((int)m->f[j].m>=num_materials || (int)m->f[j].m<0) {
   debug_printf("model_txt_load: bad material number: %d > %d at byte offset %d (face %d)\n",(int)m->f[j].m,num_materials,t.curr-t.begin,j);
   goto fatal;
  }
  m->f[j].m=mats[(int)m->f[j].m];
  model_material_used(m,m->f[j].m);//prekonvertovany material pridat
 }
 mf=model_end(m);
 debug_printf0("model_txt_load: success\n");
 for (j=0;j<num_materials;j++) {// free unnecessary materials
  mat_free(mats[j]);//ty co mas refcount>1 (jsou pouzity) tak preziji, zbytek jde pryc
 } 
 free(mats);
 debug_printf0("model_txt_load: freed materials\n");
fatal:
 if (cmap) free(cmap);
 if (amap) free(amap);
 if (tri) free(tri);
 if (data) free(data);
 if (m) model_free(m);
 if (uv) free(uv);
 if (normal) free(normal);
 return mf;
}

//TODO: map_model object

/*
nevyhody: v pameti je jak original, tak modifikovana kopie (ale pri flushi zmizi, nebot je neopuzivana)
*//*
model3d *mdef_load(const char *name) {
 nahraj .mdef soubor
 nahraj original model
 aplikuj transformace
 soupni do cache
 odehraj original model (sniz refcount)
}
*/

/*
mdef file

model={model-name.ext} //can't be another mdef
scale=1 1 1
translate=0 0 0
rotate=0 0 0
*/

@


1.3
log
@*** empty log message ***
@
text
@d40 1
a40 1
 debug_printf("model_txt_load: loading file %s\n",name);
d43 1
a43 1
 debug_printf("model_txt_load: loaded data\n");
d54 1
a54 1
 debug_printf("model_txt_load: loading mesh(es): %d\n",num_meshes);
d57 1
a57 1
  debug_printf("model_txt_load: loading mesh: %d\n",j);
d81 1
a81 1
  debug_printf("model_txt_load: vertexes loaded (%d)\n",num_vectors);
d90 1
a90 1
  debug_printf("model_txt_load: normals loaded (%d)\n",num_normals);
d109 1
a109 1
  debug_printf("model_txt_load: loaded tris: %d\n",num_tris);
d116 2
a117 2
    if (num-vert_offset>=num_vectors) {
     debug_printf("model_txt_load: too high vertex number: %d at byte offset %d (face %d)\n",num,t.curr-t.begin,i);
d122 2
a123 2
   if (tri[i*4+3]>=num_normals) {
    debug_printf("model_txt_load: too high normal number: %d at byte offset %d (face %d)\n",tri[i*4+3],t.curr-t.begin,i);
d130 1
a130 1
 debug_printf("model_txt_load: going to load materials\n",num_materials);
d140 1
a140 1
 debug_printf("model_txt_load: loading material(s): %d\n",num_materials);
d165 6
d177 1
a177 1
 debug_printf("model_txt_load: %d materials loaded\n",num_materials);
d179 4
d187 1
a187 1
 debug_printf("model_txt_load: success\n");
d192 1
a192 1
 debug_printf("model_txt_load: freed materials\n");
@


1.2
log
@*** empty log message ***
@
text
@d14 12
d28 2
a29 2
 int len,num_meshes,num_vectors,num_tris,num_normals,i,ni,dummy;
 char *data=0,*line,*key;
d37 2
d40 1
a40 1
 debug_printf("model_txt_load: loading file");
d43 1
d46 5
a51 1
  if (eqi(key,'meshes')) break;//meshes number, ignore rest
d53 2
a54 3
 if (num_meshes!=1) goto fatal;
 debug_printf("model_txt_load: loading mesh");
 free(token_readline(tp));// mesh: name, flags, material index
d56 82
a137 13
 //nacteni vertexu
 if (!token_readint(tp,&num_vectors)) goto fatal;//num of vertices
 if (num_vectors<1) goto fatal;
 uv=malloc1(2*sizeof(bfloat)*num_vectors);
 for (i=0;i<num_vectors;i++) { //for each vertex
  if(token_readint(tp,&dummy)//flags
  && token_readfloat(tp,&x)
  && token_readfloat(tp,&y)
  && token_readfloat(tp,&z)
  && token_readfloat(tp,&uv[i*2])
  && token_readfloat(tp,&uv[i*2+1])
  && token_readint(tp,&dummy)//bone index
  ) model_addvertex(m,x,y,z,0); else goto fatal;
d139 31
a169 6
 debug_printf("model_txt_load: vertexes loaded");
 if (!token_readint(tp,&num_normals)) goto fatal;//num of normals
 //nacteni normalovych vektoru
 normal=malloc1(sizeof(vector)*num_normals);
 for (i=0;i<num_normals;i++) { //for each vertex
  if(!token_readvector(tp,normal+i) goto fatal;
d171 4
a174 14
 //nacteni trianglu
 if (!token_readint(tp,&num_tris)) goto fatal;//num of tris
 tri=malloc1(4*sizeof(int)*num_tris);
 for (i=0;i<num_tris;i++) { //for each tri
  if(token_readint(tp,&dummy)//flags
  && token_readint(tp,&tri[i*4])//vertex index 1
  && token_readint(tp,&tri[i*4+1])//vertex index 2
  && token_readint(tp,&tri[i*4+2])//vertex index 3
  && token_readint(tp,&tri[i*4+3])//normal index 1
  && token_readint(tp,&dummy)//normal index 3
  && token_readint(tp,&dummy)//normal index 2
  && token_readint(tp,&dummy)//smoothing group
  ) {
  }else goto fatal;
a175 7
 while (token_readkv_sep(tp,&key,&value,':')) {
  free(key);
  if (eqi(key,'materials')) break;//materials number, ignore rest
 }

//TODO: nacitani materialu
//TODO: dodelat model
d177 6
a182 1
 debug_printf("model_txt_load: success");
d184 2
d193 2
@


1.1
log
@Initial revision
@
text
@d16 74
a89 4
 int len;
//TODO
// fs_loadfile();
 return 0;
@
