head	1.5;
access;
symbols;
locks
	bilbo:1.5; strict;
comment	@ * @;


1.5
date	2003.09.11.01.59.57;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2003.09.10.18.08.33;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.08.29.22.50.21;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.08.18.00.50.52;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.08.12.23.11.26;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.5
log
@*** empty log message ***
@
text
@/*** Sitove funkce, sitova hra */

//TODO: nedovolit pri sitove hre vice nez jednu obrazovku:
//todo: pokud bezi server ci kient socket, nepovolit dalsi hrace
//todo: pri uspesnem spojeni vyhazety vsechny hrace krome aktivniho (ci spise uz hned po napsanin connect nebo listen)

#include "b_net.h"
#include "b_con.h"
#include "b_world.h"
#include <string.h>

pnet_con_list net0[num_socket_type],net9[num_socket_type]; //konexe roztridene dle typu
int net_count[num_socket_type]; //pocet spojeni daneho typu

/** inicializace site */
void net_init(void) {
 char localhost[255];
#ifdef WIN#@@
 WSADATA wsad;
 if (WSAStartup(0x0101,&wsad)) {
  con_printf("Fatal network error: WSAStartup failed!");
 }
#endif
 gethostname(localhost,sizeof(localhost)-1);
 if (!servername) servername=strdup("Unnamed server");
 if (!nickname) nickname=strdup("Unnamed player");
 con_printf("Network init, hostname = %s",localhost);
}

/** uzavre vsechny spojeni daneho typu */
void net_killqueue(socket_type typ) {
 pnet_con_list net;
 if (!net_count[typ]) return;//zadne spojeni
 while (net0[typ]) {
  closesocket(net0[typ]->s);//zavri socket
  net=net0[typ]->next; //presun na dalsi zaznam a odalokace
  free(net0[typ]);
  net0[typ]=net;
 }
 net9[typ]=NULL;
}

#define ipv4(x) ((x)>>24)&0xff,((x)>>16)&0xff,((x)>>8)&0xff,(x)&0xff //IP adresa jako 4 slozky
//((struct in_addr *)&x)->S_un.S_un_b.s_b1,((struct in_addr *)&x)->S_un.S_un_b.s_b2,((struct in_addr *)&x)->S_un.S_un_b.s_b3,((struct in_addr *)&x)->S_un.S_un_b.s_b4

/** vypise informace o konexich daneho typu */
void net_print_connections(socket_type typ,const char *description) {
 uint i,gt=gettickcount();
 pnet_con_list net1;
 con_printf("%s : %d",description,net_count[typ]);
 net1=net0[typ];
 for (i=0;net1;i++) {
  con_printf("%d : %d.%d.%d.%d:%d, Age %d msec",i,ipv4(net1->ip),net1->port,(gt-net1->ctime));  
  net1=net1->next;
 }
}

/** debugovaci prikaz na vypis konexi*/
void cmd_net_connections(const char *param) {
// net_print_connections(listening_socket,"Listening sockets");
 net_print_connections(client_socket,"Client sockets");
 net_print_connections(server_socket,"Server sockets");
 net_print_connections(server_subsocket,"Server connections");
 unused(param);
}

/** prida socket do poolu socketu a zavre pripadna predchozi/shnila/neplatna/nakompatibilni spojeni */
net_con_list * net_add_sock(SOCKET s,socket_type typ,ip_addr ip,ip_port port) {
 #ifdef debug
  if (typ<0 || typ>num_socket_type) fatalf("net_add_sock: bad type %d",typ);
 #endif
 net_con_list *net1;
 net1=malloc1(sizeof(net_con_list));
 net1->next=NULL;
 net1->ip=ip;
 net1->port=port;
 net1->s=s;
 net1->state=0;
 net1->ctime=gettickcount();
 if (net9[typ]) {
  net9[typ]->next=net1;
  net9[typ]=net1;
 } else {
  net9[typ]=net0[typ]=net1;
 }
 net_count[typ]++;
 if (typ==server_socket)  { // server killne client
  net_clientdisconnect("Starting server");
 }
 if (typ==client_socket) { //client killne server a listenig
  net_killserver("Reconnecting as client");
 }
 return net1;
}

int16 packet_serial=0;//seriove cislo paketu - cas od casu pretece, ale s tim se pocita

/** posle po siti herni paket po danem socketu */
void net_sendpacket(net_con_list *c,packet_type pcode,int datalen,const void *data) {
 struct sockaddr_in inx;
 int inx_len;
 int packet_len=sizeof(game_packet)+datalen;
 game_packet *p=malloc(packet_len);
 packet_serial++;
 p->game_id=PACKET_GAMEID;
 p->packet_version=PACKET_VERSION;
 p->packet_id=packet_serial;
 p->packet_code=pcode;
 p->datalen=datalen;
 if (datalen) memcpy(&p->data,data,datalen);
 inx.sin_family=AF_INET;
 inx.sin_port=htons(c->port);
 inx.sin_addr.s_addr=htonl(c->ip);
 inx_len=sizeof(inx);
 sendto(c->s,(const char *)p,packet_len,0,(struct sockaddr *)&inx,inx_len);
 net_debug_print_packet("out",p);
 free(p);
} 

/** posle herni paket vsem socketum v seznamu */
void net_sendpacket_all(socket_type typ,packet_type pcode,int datalen,const void *data) {
 pnet_con_list net=net0[typ];
 while (net) { 
  net_sendpacket(net,pcode,datalen,data);
  net=net->next; //presun na dalsi spojeni
 } 
} 

/** odpoji se jakozto client (parametr je reason)
  vraci 1 pri uspechu, nebop 0 pokud neni pripojen*/
int net_clientdisconnect(const char *param) {
 if (net_count[client_socket]) {
  net_sendpacket_all(client_socket,client_disconnect,strlen(param),param);
  net_killqueue(client_socket);
  con_printf("Disconnected from server.");
  return 1;
 }
 return 0;
}

/** sestreli server - uzavre vsechny naslouchajici a obsluhovane sockety
  vraci 1 pri uspechu, nebop 0 pokud server nebezi */
int net_killserver(const char *reason) {
 if  (net_count[server_socket]) {
  net_sendpacket_all(server_subsocket,server_disconnect,strlen(reason),reason);
  con_printf("Server disconnected all players");
  net_killqueue(server_socket);
  net_killqueue(server_subsocket);
  con_printf("Server stopped listening");
  return 1;
 }
 return 0;
}

/** odstreli pripojene hrace a prestane naslouchat */
void cmd_killserver(const char *param) {
 if (!param) param="";
 if (!net_killserver(param)) con_printf("Not listening to incoming connections"); 
}

/** odpoji se jako kllient od serveru */
void cmd_disconnect(const char *param) {
 if (!param) param="";
 if (!net_clientdisconnect(param)) con_printf("Not connected to a server");
}

char* nickname;  //nickname, meno hrace [EXT]
char* servername;//jmeno serveru [EXT]

/** prikaz na zmenu jmena */
void cmd_nickname(const char *param) {
 if (empty(param)) {
  con_printf("Nickname is: %s",nickname);
  return;
 }
 if (nickname) free(nickname);
 nickname=strdup(param);
 con_printf("Nickname is set to: %s",nickname);
}

/** zkontroluje nick a pripadne ho upravi (nesmi byt prazdny nebo NULL)*/
void net_checknick() {
 if (!nickname) nickname=strdup("Anonymous player");
 if (!*nickname) { 
  free(nickname);
  nickname=strdup("Anonymous player");
 }
}

/** zkontroluje servername a pripadne ho upravi (nesmi byt prazdny nebo NULL)*/
void net_check_servername() {
 if (!servername) servername=strdup("Unnamed server");
 if (!*servername) { 
  free(servername);
  servername=strdup("Unnamed server");
 }
}


/** ze jmena(muze obsahovat i port) ziska ip a port (defaultni port je pouzit,
 pokud neni jiny specifikovan) */
int resolve_ip(const char *name,ip_addr *oip,int16 *oport,int16 default_port) {
 int16 port=0;
 char * pos;
 ip_addr ip=INADDR_NONE;
 char * newname=strdup(name);
 pos=strstr(newname,":");
 if (pos) {
  port=atoi(pos+1);
  *pos=0;
 }
 ip=inet_addr(newname);
 if (ip==INADDR_NONE) { //neni to IP
  HOSTENT *h=gethostbyname(newname);
  if (h) { //naslo se to v DNS (nebo v host, nebo kde ....)
   ip=ntohl(*(ip_addr *)(*(h->h_addr_list)));
   if (h->h_length!=4 || h->h_addrtype!=AF_INET) ip=INADDR_NONE;
  }
 }
 if (!port) port=default_port;
 *oport=port;
 *oip=ip;
 free(newname);
 return (ip!=INADDR_NONE);
}

/** pripoji se na danou adresu */
void cmd_connect(const char *param) {
 net_con_list *ctx;
 int16 port=0;
 ip_addr ip;
 if (!resolve_ip(param,&ip,&port,DEFAULT_PORT)) {
  con_printf("Can't resolve %s, cannot connect.",param);
  return;
 }
 con_printf("Connecting to %d.%d.%d.%d:%d ...",ipv4(ip),port);
 ctx=net_connect(ip,port);
 if (ctx) {
  net_checknick();
  net_sendpacket(ctx,client_want_connect,strlen(nickname),nickname);
 } else {
  con_printf("Can't connect to %d.%d.%d.%d:%d!",ipv4(ip),port);
 }
}

/** zacne naslouchat na danem portu */
void cmd_listen(const char *param) {
 int16 port=atoi(param);
 if (!port) port=DEFAULT_PORT;
 con_printf("Now listening on port %d",port);
 net_listen(port);
}

/** vytvori pripojeni k pocitaci (ip:port) vraci 0 pri chybe nebo vraci kontext spojeni pri uspechu*/
net_con_list *net_connect(ip_addr ip,ip_port port) {
 SOCKET s=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
 struct sockaddr_in inx;
 net_con_list *ctx;
 if (s==INVALID_SOCKET) return 0;
 inx.sin_family=AF_INET;
 inx.sin_port=htons(port);
 inx.sin_addr.s_addr=htonl(ip);
 if (connect(s,(struct sockaddr *)(&inx),sizeof(inx))==SOCKET_ERROR) {
  //connect u UDP jen nastavi defaultni odesilaci adresu
  closesocket(s);
  return 0;
 }
 ctx=net_add_sock(s,client_socket,ip,port);//vlozi do poolu spojeni
 return ctx;
}

/** zjisti kod chyby*/
char *net_getsockerror() {
 static char message[80];
#ifdef WIN32
 sprintf(message,"%d",WSAGetLastError());
#else
 sprintf(message,"%d",errno);
#endif
 return message;
}

/** zacne naslouchat na danem portu. Vraci 0 pri chybe */
int net_listen(ip_port port) {
 SOCKET s=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
 net_con_list *ctx;
 struct sockaddr_in ad;
 if (s==INVALID_SOCKET) {
  con_printf("net_listen: Invalid socket (port %d), error=%s",port,net_getsockerror());
  return 0;
 }
 memset(&ad,sizeof(ad),0);
 ad.sin_family=AF_INET;
 ad.sin_port=htons(port);
 ad.sin_addr.s_addr=htonl(INADDR_ANY);
 if (bind(s,(struct sockaddr *)(&ad),sizeof(ad))!=0) {
  con_printf("net_listen: Bind failed (port %d), error=%s",port,net_getsockerror());
  closesocket(s);
  return 0;
 }
 ctx=net_add_sock(s,server_socket,INADDR_ANY,port);
 ctx->c=plr->p;
 ctx->nick=strdup(nickname);
 ctx->ctime=gettickcount();
 ctx->port=0;
 ctx->ip=0;
 ctx->state=2;//connected
 return 1;
}

/** posle zpravu msg od nick vsem pripojenym */
void net_server_chatmessage(const char *nick,const char *msg) {
 int slen=strlen(nick)+strlen(msg)+3;
 char *s=malloc1(slen+1);
 sprintf(s,"<%s> %s",nick,msg);
 net_sendpacket_all(server_subsocket,chat_message,slen,s);//send to all
 display_chat_message(s);
 //send to self
 free(s);
}

net_chat_console *chatc0; //prvni zanzam v chatkonzoli
net_chat_console *chatc9; //posledni zaznam v chatkonzoli
int chat_len;//pocet zprav v chatkonzoli [EXT]
int chat_max_len=3;//pocet zprav (vyska chatwindow) [EXT]
int chat_timeout=3000;//timeout v milisekundach [EXT]

/** omezi delku chatconsole na newlen, odmazavaje stare zpravy, pokud je potreba */
void chatconsole_setlen(int newlen) {
 net_chat_console *p;
 uint tick=gettickcount();
 if (!chatc0) return;
 while (chat_len>newlen || chatc0->time+chat_timeout<tick) {
//  debug_printf("%d+%d, %d\n",chatc0->time,chat_timeout,tick);
  p=chatc0->next;
  free(chatc0->msg);
  free(chatc0);
  chatc0=p;
  chat_len--;
  if (!chatc0) {
   chatc9=0;
   return;
  }
 }
}

/** prida message do chatconsole */
void chatconsole_add(const char *s) {
 net_chat_console *p;
 if (!chat_max_len) return; //chatbox vypnut
 chatconsole_setlen(chat_max_len-1);//udelej misto
 p=malloc1(sizeof(net_chat_console));
 p->next=0;
 p->len=strlen(s);
 p->msg=strdup(s);
 p->time=gettickcount();
 //pridat do seznamu
 if (chatc9) chatc9->next=p;
 else chatc0=p;
 chatc9=p;
 chat_len++;
}

char * msgs=0;//buffer na zpravy

/** vrati text chatu, orizly na max. velikost obrazovky a jednotlive radky oddelene newlinem */
const char * chatconsole_printstring() {
 int tlen=0,tpos=0;
 int thislen;
 int maxlen=maxx/fontsizex;
 net_chat_console *p;
 if (!chat_len) return "";
 chatconsole_setlen(chat_max_len);
 if (!chat_len) return "";
 p=chatc0;
 if (!p) fatal("messages disappeared");
 while(p) { //zjisti delku
  tlen+=min(maxlen,p->len)+1;
  p=p->next;
 }
 if (msgs) free(msgs);
 msgs=malloc1(tlen);
 p=chatc0;
 while(p) { //zkopiruje zpravy
  thislen=min(maxlen,p->len);
  strncpy(msgs+tpos,p->msg,thislen);
  tpos+=thislen;
  msgs[tpos]='\n';
  p=p->next;
  if (p) tpos++;
 }
 msgs[tpos]=0;
 return msgs;
}

/** zobrazi chat message na obrazovku a do chatconsole*/
void display_chat_message(const char *s) {
 chatconsole_add(s);
 con_print(s);
}

/** say - poslani zpravy vsem */
void cmd_say(const char *param) {
 if (empty(param)) return;
 net_checknick();
 if (net_count[client_socket]) { //jsem klient
  debug_printf("client sending chat");
  net_sendpacket_all(client_socket,chat_message,strlen(param),param);//posli na server
 } else if (net_count[server_socket]) { //jsem server
  debug_printf("server sending chat");
  net_server_chatmessage(nickname,param);//posli klientum
 } else con_printf("Not connected.");
}

/** jede tick na klientu */
void net_client() {
 pnet_con_list net1;
 //obslouzi client sockety - posli update na aserver, atd ....
 net1=net0[client_socket];
 while (net1) {
  net_handle_client(net1);
  net1=net1->next;
 }
}

/** pro dany ip/port vrati kontext, pokud kontext neexistuje, vytvori novy */
net_con_list *net_ip_context(SOCKET s,ip_addr ip,int16 port) {
 net_con_list *p=net0[server_subsocket];
 while (p) {
  if (ip==p->ip && port==p->port) return p;
  p=p->next;
 }
 return net_add_sock(s,server_subsocket,ip,port);
 //kontext neni
}

/** vypise informace o prislem paketu na konzoli */
void net_debug_print_packet(char *info,game_packet *p) {
 char *pt=0;
 switch (p->packet_code) {
  case client_want_connect:pt="client_want_connect";break;
  case client_disconnect:pt="client_disconnect";break;
  case client_send_update:pt="client_send_update";break;
  case client_confirm:pt="client_confirm";break;
  case client_request_update:pt="client_request_update";break;
  case client_request_object:pt="client_request_object";break;
  case client_want_info:pt="client_want_info";break;
  case client_want_score:pt="client_want_score";break;
  case server_accept_connect:pt="server_accept_connect";break;
  case server_refuse_connect:pt="server_refuse_connect";break;
  case server_disconnect:pt="server_disconnect";break;
  case server_object_info:pt="server_object_info";break;
  case server_object_update:pt="server_object_update";break;
  case server_object_delete:pt="server_object_delete";break;
  case server_player_info:pt="server_player_info";break;
  case server_map_change:pt="server_map_change";break;
  case server_score:pt="server_score";break;
  case server_info:pt="server_info";break;
  case chat_message:pt="chat_message";break;
 }
 if (!pt) con_printf("Packet %s: %d bytes, unknown type %d",info,p->datalen,p->packet_code);
 else con_printf("Packet %s: %d bytes, type %s",info,p->datalen,pt);
}

/** vraci true, pokud je packet platny (spravna verze, delka, atd ....) */
int net_validate_packet(game_packet *p,int16 packet_len) {
 debug_printf("Validating packet ...\n");
 if (packet_len<sizeof(game_packet)) return 0;//prilis maly paket
 debug_printf("is large enough ... %d < %d\n",packet_len,sizeof(game_packet));
 if (p->game_id!=PACKET_GAMEID || p->packet_version>PACKET_VERSION) return 0;//spatna hra, ci verze paketu, taky zahodime
 debug_printf("is good version ...\n");
 if (p->datalen+(short)sizeof(game_packet)!=packet_len) return 0;//spatna velikost paketu - neprisel cely, nebo prislo navic nejake smeti
 debug_printf("is good length\n");
 return 1;
}

/** zkotroluje packet typu string, jestli tam jsou rozumna data (a zadne divoke znaky) */
void net_checkstringpacket(game_packet *p) {
 int i;
 for (i=0;i<p->datalen;i++) {
  if (p->data[i]) {
   if (p->data[i]<32 || p->data[i]>126) p->data[i]='?';//neplatny znak
  }
 }
}


/** proscanuje servery (posle broadcast packet) na danem portu*/
void net_scan(const char *param) {
 net_con_list *ctx;
 short port=atoi(param);
 if (!port) port=DEFAULT_PORT;
 ctx=net_connect(INADDR_BROADCAST,port);
 if (!ctx) {
  con_printf("Scan failed.");
  return;
 }
 net_sendpacket(ctx,client_want_info,0,0);
 con_printf("Scan started...");
 //ted staci jen cekat, vysledky by se mely zacit objevovat na konzoli
 //TODO: pokud uz nejaky broadcast bezi tak reuse socket .... a nemel by killit server
}

void cmd_map(const char* param);//forward

/** obslouzi jiz pripojeny socket z klienta na server */
void net_handle_client(net_con_list *c) {
 struct timeval tmout={0,0};
 fd_set sockets;
 struct sockaddr_in adr; 
 int adr_len=sizeof(adr);
 char buf[16385];//na prichozi packet
 short buf_len;
 game_packet *p;
 FD_ZERO(&sockets);
 FD_SET(c->s,&sockets);
 while (select(1,&sockets,NULL,NULL,&tmout)) { //nejaky paket ceka?
  buf_len=recvfrom(c->s,buf,sizeof(buf)-1,0,(struct sockaddr *)&adr,&adr_len);
  if (buf_len==SOCKET_ERROR) break;//nejaka chyba
  debug_printf("Get packet of length %d\n",buf_len);
  if (c->ip!=ntohl(adr.sin_addr.s_addr) || c->port!=ntohs(adr.sin_port)) {
   if (c->ip!=INADDR_BROADCAST) { // a ani to neni odpoved na broadcast
    debug_printf("Invalid packet source - not from server %d,%d.%d.%d\n",ipv4(c->ip));
    continue;//paket neni ze serveru, zahod
   }
  }
  p=(game_packet *)&buf;
  if (!net_validate_packet(p,buf_len)) continue;//spatny paket
  buf[buf_len]=0;//dopln nulu za paket (kvuli string packetum)
  net_debug_print_packet("incoming",p);
  //TODO
  switch (p->packet_code) {
   case server_accept_connect:	//spojeni prijato (text=motd)
    net_checkstringpacket(p);
    c->nick=strdup(p->data);
    con_printf("Connected to server %s.",c->nick);
    c->state=1;
    continue;
   case server_refuse_connect:	//spojeni zamitnuto (text=reason)
    net_checkstringpacket(p);
    con_printf("Connected refused by server: %s",p->data);
    continue;
   case server_disconnect:	//server konci (text=reason)
    net_checkstringpacket(p);
    con_printf("Server closed connection: %s",p->data);
    continue;
   case server_world:	//update ze serveru - velky
    net_accept_world(p->datalen,p->data);
    continue;
   case server_map_change:	//zmena mapy na serveru (text=map name)
    net_checkstringpacket(p);
    con_printf("Server is using map: %s",p->data);
    cmd_map(p->data);//nahraje mapu
    net_sendpacket(c,client_request_update,0,0);    
    continue;
   case server_info:		//infopaket od serveru
    con_printf("Info from : %d.%d.%d.%d:%d",ipv4(ntohl(adr.sin_addr.s_addr)),ntohs(adr.sin_port));
    //TODO: mozna poslat vic ze serveru
    continue;
   case chat_message:		//chat message
    net_checkstringpacket(p);
    display_chat_message(p->data);
    continue;
  }
 }
}

object_netque *net_obj;//objekty urcene k poslani pres sit

/** prida objekt do fronty objektu k poslani */
void netque_add(object3d *obj,object_netque_action a) {
 object_netque *o;
 object_netque *t=net_obj;
 while(t) { //test jestli uz neni ve fronte
  if (t->obj==obj) { //uz tam ten objekt mame   
   if (a==send_update && t->act==send_object) return;
   t->act=a;//update kodu
   return;
  }
  t=t->next;
 }
 o=malloc1(sizeof(object_netque));
 o->act=a;
 o->obj=obj;
 o->next=net_obj;
 net_obj=o;
}

/** pridani objektu - server posle zpravu o objektu */
void net_addobject(object3d *obj) {
 netque_add(obj,send_object);
}

/** pridani objektu - server posle update objektu */
void net_updateobject(object3d *obj) {
 netque_add(obj,send_update);
}

/** odebrani objektu - server posle zpravu o objektu */
void net_killobject(object3d *obj) {
 netque_add(obj,send_delete);
}

// max. pocet objektu v sitove hre cca 16000
// (to je dano omezenim velikosti paketu, navic i pri mensim poctu (radove stovky) uz
// putuje po siti celkem dost dat ...(radove desitky az stovky kb/sec))

/** do site posle idcka vsech objektu a pak pro kazdy objekt jeste kompletni init packet */
void net_send_world(net_con_list *ctx,worldspawn *w) {
 int i;
 int n_obj=w->obj.numobj;
 int *b=malloc0(n_obj*sizeof(int));
 for (i=0;i<n_obj;i++) { //posli id vsech objektu
  b[i]=w->obj.obj[i]->id;
 }
 net_sendpacket(ctx,server_world,n_obj*sizeof(int),(void *)b);
 for (i=0;i<n_obj;i++) { //posli vsechny objekty
  net_send_object(ctx,w->obj.obj[i],0);
 }
 free(b);
}

/** vytvori paket k poslani pres sit*/
packet *packet_create(int alloc_len) {
 packet *px=malloc1(alloc_len+sizeof(packet));
 px->maxlen=alloc_len;
 px->len=0;
 return px;
}

/** prida do paketu data*/
void packet_add(packet **p,int len,const void *data) {
 if ((*p)->len+len>(*p)->maxlen) { //maly paket?
  while ((*p)->len+len>(*p)->maxlen) { //zvetsime
   (*p)->maxlen*=2;
  }
  (*p)=realloc(*p,(*p)->maxlen+sizeof(packet)); //realokace
 }
 memcpy((*p)->data+(*p)->len,data,len);//zkopiruj data do packetu
}

/** prida do paketu int*/
void packet_add_int(packet **p,int data) {
 packet_add(p,sizeof(data),&data);
}

/** prida do paketu byte*/
void packet_add_byte(packet **p,char data) {
 packet_add(p,sizeof(data),&data);
}

/** prida do paketu vektor (s konverzi do singlevectoru) */
void packet_add_vect(packet **p,vector v) {
 singlevector v2;
 v2.x=v.x;
 v2.y=v.y;
 v2.z=v.z;
 packet_add(p,sizeof(v2),&v2);
}

/** prida do paketu rotation (s konverzi do singlevectoru) */
void packet_add_rot(packet **p,rotation v) {
 singlevector v2;
 v2.x=v.x;
 v2.y=v.y;
 v2.z=v.z;
 packet_add(p,sizeof(v2),&v2);
}

/** prida do paketu sdring (pascal style) */
void packet_add_string(packet **p,const char *s) {
 int len=strlen(s);
 if (len>255) len=255;
 packet_add_byte(p,(unsigned char)len);
 packet_add(p,len,s);
}

/** posla vykonstruovany paket po siti */
void net_sendpacket_s(net_con_list *c,packet_type pcode,packet *p) {
 net_sendpacket(c,pcode,p->len,p->data);
}

/** posla hraciinformace o nem samem */
void net_send_playerinfo(net_con_list *ctx,client *c) {
 packet *p=packet_create(512);
 packet_add_int(&p,c->who->id);
 packet_add_int(&p,(int)object_getpropf(c->who,"health"));
 packet_add_int(&p,c->frags);
 packet_add_vect(&p,c->who->p);
 packet_add_vect(&p,c->who->d);
 net_sendpacket_s(ctx,server_player_info,p);
 free(p);
}

/** posle na sevre svoje zmeny */
void net_send_player_update(net_con_list *ctx,client *c,object3d *shot) {
 packet *p=packet_create(512);
 packet_add_vect(&p,c->who->p);
 packet_add_vect(&p,c->who->d);
 packet_add_vect(&p,c->who->head);
 packet_add_vect(&p,c->who->up);
 packet_add_vect(&p,c->who->left);
 if (shot) { //bylo li vystreleno
  packet_add_string(&p,shot->type->classname);
  packet_add_vect(&p,shot->p);
  packet_add_vect(&p,shot->d);
  packet_add_rot(&p,shot->rot);
  packet_add_rot(&p,shot->rotplus);
 } else { // neby.o strileno
  packet_add_string(&p,"");
 }
 net_sendpacket_s(ctx,client_send_update,p);
 free(p);
}

/** posle cely objekt, nebo eventuelne jenom update paket */
void net_send_object(net_con_list *ctx,object3d *o,int only_update) {
 char *modelname="";
 packet *p=packet_create(512);
 packet_add_int(&p,o->id);
 packet_add_vect(&p,o->p);
 packet_add_vect(&p,o->d);
 packet_add_rot(&p,o->rot);
 packet_add(&p,sizeof(o->f),&o->f);
 packet_add_string(&p,modelname);
 if (only_update) {
  net_sendpacket_s(ctx,server_object_update,p);
 } else {
  packet_add_string(&p,o->type->classname);
  if (o->model && o->model->manager && o->model->manager->name) modelname=o->model->manager->name;
  net_sendpacket_s(ctx,server_object_info,p);
 }
 free(p);
}

#define min_servertick 40 //minimalni pocet msec mezi posilanim updatu (aby se nzahltila sit nadbytecnymi pakety, pokud by se spustil server na prilis rychlem pocitaci)

/** posilani zprav ktere nejsou reakci na jine (updaty ze serveru, atd ....) */
void net_servertick(net_con_list *ctx) {
 object_netque *nq;
 net_con_list *c;
 static uint last_servertick;
 if (last_servertick+min_servertick<gettickcount()) return;//neposilat updaty prilis casto
 last_servertick=gettickcount();
 //send_added+killed
 while (net_obj) {
  nq=net_obj;
  switch (nq->act) {
   case send_object: // vsem kopletni info
    c=ctx;
    while(c) {
     net_send_object(c,nq->obj,0);
     c=c->next;
    }
    break;
   case send_update: // vsem update
    c=ctx;
    while(c) {
     net_send_object(c,nq->obj,1);
     c=c->next;
    }
    break;
   case send_delete://posli vsem info o smazani objektu 
    c=ctx;
    while(c) {
     net_sendpacket(c,server_object_delete,sizeof(int),nq->obj);
     c=c->next;
    }
    break;
  }
  net_obj=nq->next; //dalsi objekt
  free(nq);
 }
 //zbytek se resi v klasickem serverloopu
}

typedef struct { //klient posila update o sobe
 singlevector p;  //poloha
 singlevector d;  //kam miri .... rychlost a smer
 singlevector head,top,left;//heading
} player_update_client;

typedef struct { //hlavicka net_scoreboard, je nasledovana num_players krat scoreboard_item
 int num_players;//pocet hracu
 int you_are;    //ktyery z nich je ten, komu je to posilano
} net_scoreboard_header;

typedef struct { // skore pro jednoho hrace
 int frags;//pocet fragu hrace
 int time; //jak dlouho je pripojen na serveru
 int deaths;//pocet smrti hrace
 int ping;//jeho ping time
 //pak nasleduje v paketu za timto pascalsky string (jmeno hrace)
} net_scoreboard_item;

net_scoreboard_header score_head; //nacachovany score header;
net_scoreboard_item *score_array;//nacachovany score array;
char **score_names;//nacachovany score array;
int score_array_len=0;//alokovana velikost poli score_names a score_array

/** nastavi pocet zaznamu ve scorebardu (vcetne realokace/aloikace pameti) */
void scoreboard_setlen(int n_players) {
 int i;
 if (score_array_len<n_players) {
  if (!score_array_len) {
   score_array_len=n_players;
   score_array=malloc1(score_array_len*sizeof(net_scoreboard_item));
   score_names=malloc0(score_array_len*sizeof(char *));
  } else {
   i=score_array_len;
   score_array_len=n_players;
   score_array=realloc1(score_array,score_array_len*sizeof(net_scoreboard_item));
   score_names=realloc1(score_names,score_array_len*sizeof(char *));
   for(;i<score_array_len;i++) { //vynulovat zbytek pole
    score_names[i]=0;
   }
  }
 }
 score_head.num_players=n_players;
}

/** updatuje scoreboard */
void update_scoreboard(object3d *you_are) {
 net_con_list *c;
 int i,gt;
 scoreboard_setlen(nplayers);
 i=0;
 gt=gettickcount();
 c=net0[server_socket];
 while (c) { // serverove hrace
  score_names[i]=c->nick;
  score_array[i].frags=c->c->frags;
  score_array[i].deaths=c->c->deaths;
  score_array[i].ping=-1;
  score_array[i].time=gt-c->ctime;
  if (c->c->who==you_are) score_head.you_are=i;
  c=c->next;
  i++;
 }
 c=net0[server_subsocket];
 while (c) { // a ostatni hrace
  score_names[i]=c->nick;
  score_array[i].frags=c->c->frags;
  score_array[i].deaths=c->c->deaths;
  score_array[i].ping=-1;
  score_array[i].time=gt-c->ctime;
  if (c->c->who==you_are) score_head.you_are=i;
  c=c->next;
  i++;
 }
 if (i!=nplayers) fatalf("update_scoreboard:  i!=nplayers (%d,%d)",i,nplayers);
}

/** posle score po siti */
void net_send_scoreboard(net_con_list *ctx) {
 int i;
 packet *p=packet_create(512);
 update_scoreboard(ctx->c->who);
 packet_add(&p,sizeof(score_head),&score_head);
 for (i=0;i<score_head.num_players;i++) {
  packet_add(&p,sizeof(net_scoreboard_item),&score_array[i]);
  packet_add_string(&p,score_names[i]);
 }
 net_sendpacket_s(ctx,server_score,p);
 free(p);
}

/** packet parse: get int */
int pparse_int(int *datalen, void **data,int *result) {
 if (*datalen<sizeof(int)) return 0;
 *result=**(int **)data;
 (*(int **)data)++;
 return 1;
}

/** packet parse: get data */
int pparse(int *datalen, void **data,int reslen,void *result) {
 if (*datalen<reslen) return 0;
 memcpy(result,*data,reslen);
 *((char **)data)+=reslen;
 return 1;
}

char *score_names2=0;//promenna na udrzeni jmen pro score

/** prijme a zpracuje paket obsahujici score tabulku pro vsechy pripojene hrace */
void net_receive_scoreboard(int datalen,void *data) {
 //TODO: tohle neni prilis odolne vuci vadnemu packetu
 int i,offset;
 char *s_name,*orig_data;
 char ssize;
 net_scoreboard_header h;
 if (!pparse(&datalen,&data,sizeof(h),&h)) return;
 if ((uint)datalen<(sizeof(net_scoreboard_item)+1)*h.num_players) return;//+1 - string. Prilis maly paket - zahodime
 score_head=h;
 scoreboard_setlen(h.num_players);
 s_name=malloc0(datalen+1);//+1 na null terminator
 orig_data=(char *)data;
 memcpy(s_name,data,datalen);//kopie dat
 for (i=0;i<h.num_players;i++) {
  if (!pparse(&datalen,&data,sizeof(h),&h)) break;
  s_name+=sizeof(h);
  if (!pparse(&datalen,&data,sizeof(net_scoreboard_item),&score_array[i])) break;
  if (!pparse(&datalen,&data,sizeof(char),&ssize)) break;//dlka jmena (retezce)
  offset=(char *)data-orig_data;
  datalen-=offset;
  data=(char *)data+offset;
  if (datalen<0) break;//chybny paket
  score_names[i]=s_name+offset;
  s_name[offset+ssize]=0;//null terminated string
 }
 for (;i<h.num_players;i++) { // vadne pakety (eventuelni zbytek) -> nejak se vyresi
  score_array[i].deaths=-1;
  score_array[i].frags=-1;
  score_array[i].ping=-1;
  score_array[i].time=-1;
  score_names[i]="? (error)";//aby nedoslo k hrabnuti mimo pamet (ale jinak ve zbylych pozicich scoreboardu budou nesmysly)
 }
 if (score_names2) free(score_names2);
 score_names2=s_name;
 score_head=h;
}

/** gl show scoreboard (volano pri if (score is down) pro kazdeho hrace) */
void gl_show_scoreboard() {
 static uint lastwanttime;
 net_scoreboard_item *it;
 int ih,tih,i,np,t;
 char buf[200];
 if (net0[server_socket]) { //jsem server
  update_scoreboard(net0[server_socket]->c->who); //zjistim si to sam
 } else if (lastwanttime+2000<gettickcount()) { //jsem klient - chci update ze serveru
  net_sendpacket_all(client_socket,client_want_score,0,0);
  lastwanttime=gettickcount();
 }
 np=score_head.num_players;
 ih=maxx/(np+1);//item height
 if (ih>fontsizex) ih=fontsizex;
 tih=ih*(np+1);
 sprintf(buf,"%20s %6s%6s%6s\n","Nickname","Frag","Death","Time");
 glColor4ub(255,255,255,128);
 gltext(buf);
 for (i=0;i<np;i++) {
  it=&score_array[i];
  t=it->time/1000;
  if (i==score_head.you_are) {
   glColor4ub(255,255,128,128);
  } else {
   glColor4ub(128,128,128,128);
  }
  sprintf(buf,"%20s %6d%6d%3d:%2d\n",score_names[i],it->frags,it->deaths,t/60,t%60);
  gltext(buf);
 } 
 //TODO: show scores; -> dodelat CRITICAL
 //TODO: presunout do b_gl nebo b_menu nebo tak nejak 
}

/** prijme a zpracuje seznam idcek objektu tvorici svet. Inteligentne smnaze neexistujici objekty a prida nove (ackoliv nezna jejich pozici a co jsou zac, ty obvykle prichazeji pozdeji v jinem paketu (object_info)) */
void net_accept_world(int datalen,void *data) {
 //akorat posle chrchel idcek
// TODO:dodelat
 //TODO: zlikvidovat vsechny objekty a misto nich nacpat novy (intelignetne, stary si chvili schovat a kde se id shodije, tak tam nechat ten stary)
 //(cpoz bude dost tezky)

}

/** prijme a zpracuje paket menici jeden objekt (poloha, rychlost, atd ...)*/
void net_accept_object_update() {
 // TODO:dodelat
 //TODO: nevyresene: jak zpracovavat rozdily mezi pohybem u klienta a u serveru? u objektu ma server vzdy pravdu, ale u hrace to takhle jednoduse nejde (co vysoke pingy?)
}

/** prijme a zpracuje  paket posilajici uplne informace o objektu (vc. classname a modellu ...) */
void net_accept_object_info() {
// TODO:dodelat
}

/** prijme a zpracuje  paket oznamujici smazani objektu */
void net_accept_object_delete() {
// TODO:dodelat
}

/** odmazne ze hry jednoho klienta */
void killclient(client *c) {
 int i,j;
 players *pl=plr,*prev=0;
 c->who->f.is_destroyed=1;
 ai_call_destroy(c->who);
 world_kill_object(world,c->who);
 while (pl) { // smazat ze seznamu
  if (pl->p==c) {
   if (prev) prev->next=pl->next;
    else plr=pl->next;
   free(pl);
   nplayers--;
   break;
  }
  prev=pl;
  pl=pl->next;
 }
 for (i=0;i<screens;i++) {//smazat ze seznamu obrazovek
  if (vplayer[i]==c) {//nalezen, smazat
   if (c->controller==human) player_screens--;
   for(j=i+1;j<screens;j++) {
    vplayer[j-1]=vplayer[j];
   }
   screens--;
   break;
  }
 }
 free(c);
 player_realloc_screens();
 activeplayer_check();
}

/** odstrani sitoveho klienta ze hry */
void net_remove_player(net_con_list *ctx) {
 net_con_list *ct=net0[server_subsocket];
 killclient(ctx->c);
 free(ctx->nick);
 if (ct==ctx) { //odstrani prvni
  net0[server_subsocket]=ct->next;
  free(ctx);
 }
 while (ct) { //odstran ze seznamu
  if (ct->next==ctx) {
   free(ctx);
  }
  ct=ct->next;
 }
}

/** prida sitoveho klienta do hry */
void net_add_player(net_con_list *ctx) {
 ctx->c=addhumanplayer(world,0);
 ctx->c->controller=network;
// ctx->c->data.c=ctx;
}

/** obslouzi socket naslouchajici na serverru */
void net_handle_server_packet_in(pnet_con_list c) {
 struct timeval tmout={0,0};
 fd_set sockets;
 struct sockaddr_in adr; 
 int adr_len=sizeof(adr);
 char buf[16385];//na prichozi packet
 short buf_len;
 net_con_list *ctx;
 game_packet *p;
 FD_ZERO(&sockets);
 FD_SET(c->s,&sockets);
 while (select(1,&sockets,NULL,NULL,&tmout)) { //nejaky paket ceka?
  buf_len=recvfrom(c->s,buf,sizeof(buf)-1,0,(struct sockaddr *)&adr,&adr_len);
  debug_printf("Get packet of length %d\n",buf_len);
  p=(game_packet *)&buf;
  if (!net_validate_packet(p,buf_len)) continue;//spatny paket
  buf[buf_len]=0;//dopln nulu za paket (kvuli string packetum)
  net_debug_print_packet("incoming",p);
  ctx=net_ip_context(c->s,ntohl(adr.sin_addr.s_addr),ntohs(adr.sin_port));
  if (ctx->state) { //je-li pripojen
   switch (p->packet_code) {
    case client_disconnect:	//klient se odpojuje od serveru
     if (ctx->state==2) {
      con_printf("%s left game.",ctx->nick);
      net_remove_player(ctx);
     }
     continue;
    case client_send_update:	//klient posila update
     //TODO
     continue;
    case client_request_update://klient chce poslat stav vsech objektu, explicitne (void)
     if (ctx->state==1) {
      con_printf("%s entered game.",ctx->nick);
      net_add_player(ctx);
     }
     ctx->state=2;//uz je fakt ve hre, kdyz chce update
     net_send_world(ctx,world);
     net_send_scoreboard(ctx);
     // a jeste se mu posle scoreboard -> kdo je ve hre ...
     continue;
    case client_request_object:	//klient chce poslat stav konkretniho objektu (id);
     //TODO
     continue;
    case chat_message:		//chat message
     net_checkstringpacket(p);
     net_server_chatmessage(ctx->nick,p->data);
     continue;
   }
  } else {
   //na stavu nezalezi
   switch (p->packet_code) {
    case client_want_connect: //klient se chce pripojit k serveru (text=nickname)
     ctx->state=1;
     net_checkstringpacket(p);
     ctx->nick=strdup(p->data);
     con_printf("%s is connecting.",ctx->nick);
     net_check_servername();
     net_sendpacket(ctx,server_accept_connect,strlen(servername),(void *)servername);
     net_sendpacket(ctx,server_map_change,strlen(current_map_name),(void *)current_map_name);
     continue;
    case client_want_info:    //klient chce poslat info paket (void)
     net_sendpacket(ctx,server_info,0,0);	//TODO: poslat i nejaka data (mozna, moznost rozsireni do budoucna)
     continue;
    case client_want_score:    //klient chce poslat score
     net_send_scoreboard(ctx);
     continue;
   }
  }
 }
}

/** vola se po zmene mapy - po siti se posle info */
void map_change_handler() {
 if (net_count[client_socket]) {  //disconnect, kdyz si v konzoli samovolne zmenim mapu
  net_clientdisconnect("Local map change");
 }
 if (net_count[server_subsocket]) { //oznamit klientum ze se zmenila mapa (pokud nejaky jsou)
  net_sendpacket_all(server_subsocket,server_map_change,strlen(current_map_name),(void *)current_map_name);
 }
}

/** jeden tick na serveru */
void net_server() {
 pnet_con_list net1;
 //obslouzi server sockety
 net1=net0[server_socket];
 while (net1) {
  net_handle_server_packet_in(net1);
  net1=net1->next;
 }
 // vyresil prichozi, ted zacne odesilat odchozi
 net_servertick(net0[server_subsocket]);
}

/** konec site */
void net_close(void) {
#ifdef WIN32
 WSACleanup();
#endif
}

//TODO: tickcounty se nekde porovnavaji spatne (problem jednou za 20 az 40 dni, kdy to pretece, ale 20 dni stejne windowsy nebezi ...)@


1.4
log
@*** empty log message ***
@
text
@d17 2
a19 1
 char localhost[255];
d23 1
d275 5
a279 1
 _snprintf(message,sizeof(message),"%d",WSAGetLastError());
d736 1
a736 1
#define min_servertick 40
d788 5
a792 5
typedef struct {
 int frags;
 int time;
 int deaths;
 int ping;
d799 1
a799 1
int score_array_len=0;
d886 1
d958 1
d961 1
a961 1
// TODO:dodelat!!! CRITICAL
d963 1
d967 1
d969 2
a970 1
// TODO:dodelat!!! CRITICAL
d973 1
d975 1
a975 1
// TODO:dodelat!!! CRITICAL
d978 1
d980 1
a980 1
// TODO:dodelat!!! CRITICAL
d1137 1
d1139 1
@


1.3
log
@*** empty log message ***
@
text
@d1 6
d9 2
a10 2

/*** Sitove funkce */
d17 9
a25 2
 con_printf("Network init");
 //TODO: mozna v budoucnu tu i neco bude (WSAINIT?)
a29 1
 int i;
d41 1
a41 1
#define ipv4(x) (x)&0xff,((x)>>8)&0xff,((x)>>16)&0xff,((x)>>24)&0xff //IP adresa jako 4 slozky
d46 1
a46 1
 int i,gt=gettickcount();
d58 4
a61 3
 net_print_connections(listening_socket,"Listening sockets");
 net_print_connections(client_socket,"Client (this) to server sockets");
 net_print_connections(server_socket,"Server (this) to client sockets");
d66 1
a66 1
void net_add_sock(SOCKET s,socket_type typ,ip_addr ip,ip_port port) {
d70 1
a70 1
 pnet_con_list net1;
d85 1
a85 1
 if (typ==server_socket || typ==listening_socket)  { // server killne client
d91 1
d97 3
a99 1
void net_sendpacket(SOCKET s,packet_type pcode,int datalen,const void *data) {
d109 6
a114 1
 send(s,&p,packet_len,0);
d122 1
a122 1
  net_sendpacket(net->s,pcode,datalen,data);
d129 1
a129 1
int  net_clientdisconnect(const char *param) {
d142 2
a143 2
 if  (net_count[server_socket]+net_count[listening_socket]) {
  net_sendpacket_all(server_socket,server_disconnect,strlen(reason),reason);
d146 1
a146 1
  net_killqueue(listening_socket);
d165 2
a166 1
char* nickname;//nickname
d179 1
a179 1
/** zkontroluje nc a pripadne ho upravi (nesmi byt prazdny nebo NULL)*/
d188 10
d202 15
a216 2
 if (strstr(name,':')) {
  //TODO
d218 5
a222 5
 //TODO
 if (!port) port=DEFAULT_PORT;
 oport=port;
 //TODO
 return 0;
d227 1
d235 7
a241 1
 net_connect(ip,port);
d252 2
a253 2
/** vytvori pripojeni k pocitaci (ip:port) vraci 0 pri chybe*/
int net_connect(ip_addr ip,ip_port port) {
d256 1
d262 1
d266 9
a274 4
 net_add_sock(s,client_socket,ip,port);//vlozi do poolu spojeni
 net_checknick();
 net_sendpacket(s,client_want_connect,strlen(nickname),nickname);
 return 1;
d280 1
d283 1
a283 1
  con_printf("net_listen: Invalid socket (port %d)",port);
d291 1
a292 1
  con_printf("net_listen: Bind failed (port %d)",port);
d295 7
a301 6
 if (listen(s,SOMAXCONN)!=0) {
  closesocket(s);
  con_printf("net_listen: Listen failed (port %d)",port);
  return 0;
 }
 net_add_sock(s,listening_socket,INADDR_ANY,port);
d310 1
a310 1
 net_sendpacket_all(server_socket,chat_message,slen,s);//send to all
d316 80
d399 7
a405 4
 if (net_count[client_socket]) {
  net_sendpacket_all(client_socket,chat_message,strlen(param),param);
 } else if (net_count[server_socket]+net_count[listening_socket]) {
  net_server_chatmessage(nickname,param);
a408 5
/** obslouzi jiz pripojeny socket z klienta na server */
void net_handle_client(pnet_con_list c) {
  //TODO: read packets from server, send updates, chat, etc ...
}

d416 1
d420 82
a501 2
/** obslouzi listening sockety - prijmi nove pripojeni */
void net_handle_incoming(pnet_con_list c) {
d504 16
a519 12
 while (c) {
  FD_ZERO(&sockets);
  FD_SET(c->s,&sockets);
  if (select(1,&sockets,NULL,NULL,&tmout)) { //neco k akceptovani
   struct sockaddr_in inx; 
   int inx_len;
   SOCKET s;
   //TODO: predelat, tohle neni TCP! misto toho nacteni paketu a rozskatulkovani
   //TODO: prijde-li packet, tak checknout jestli uz neni znamy ip a podle toho
   // reagovat
   s=accept(c->s,(struct sockaddr *)(&inx),&inx_len);
   net_add_sock(s,server_socket,ip_address(inx),inx.sin_port);
d521 310
d832 72
d905 44
d951 156
a1106 4
/** obslouzi jiz pripojeny socket na serveru */
void net_handle_connected(pnet_con_list c) {
  //TODO
  //write only, cteni paketu se deje v net_handle_incoming
d1112 1
a1112 7
 //obslouzi listening sockety - prijmi nove pripojeni
 net1=net0[listening_socket];
 while (net1) {
  net_handle_incoming(net1);
  net1=net1->next;
 }
 //obslouzi jiz pripojene sockety
d1115 1
a1115 1
  net_handle_connected(net1);
d1118 2
d1124 2
a1125 1
//TODO
d1127 1
a1127 1
}@


1.2
log
@*** empty log message ***
@
text
@d11 2
a12 1
//TODO
d15 16
a30 1
#define ipv4(x) ((struct in_addr *)&x)->S_un.S_un_b.s_b1,((struct in_addr *)&x)->S_un.S_un_b.s_b2,((struct in_addr *)&x)->S_un.S_un_b.s_b3,((struct in_addr *)&x)->S_un.S_un_b.s_b4
d45 1
a45 1
void cmd_net_connections(char *param) {
a51 6
/** zavre spojeni v danem socketu */
void net_kill_sock(pnet_con_list *c,socket_type typ) {
}

/** */

d63 1
d72 39
a110 1
 if (typ==server_socket && net_count[client_socket])  { // server killne client
d112 2
d115 9
a123 1
 if (typ==client_socket && (net_count[server_socket]+net_count[listening_socket])  { //client killne server a listenig
d126 25
d152 46
d212 3
a214 2
 net_add_sock(s,client_socket,ip,port);
//TODO
d240 1
a240 3
 
 net_add_sock(s,server_socket,INADDR_ANY,port);
//TODO
d244 26
d272 6
a277 1
//TODO
d284 14
a297 8
 sockets.fd_count=1;
 sockets.fd_array[0]=c->s;
 if (select(1,&sockets,NULL,NULL,&tmout)) { //neco k akceptovani
  struct sockaddr_in inx; 
  int inx_len;
  SOCKET s;
  s=accept(c->s,(struct sockaddr *)(&inx),&inx_len);
  net_add_sock(s,server_socket,inx.sin_addr.S_un.S_addr,inx.sin_port);
d301 1
a301 1
/** obslouzi jiz pripojene sockety */
d303 2
a304 1

@


1.1
log
@Initial revision
@
text
@d6 3
d14 27
a40 11
typedef enum { //stav site - jestli je nekam pripojen
 disconnected, //nepripojen
 netclient,       //pripojen na server
 netserver,       //sam je server
} net_state;

typedef enum { //typ socketu
 listening_socket, //naslouchajici socket
 client_socket,    //klient, na druhe strane je server
 server_socket,    //server, na druhe strane je klient
} socket_type;
d43 25
a67 2
void net_add_sock(SOCKET s,socket_type typ) {
 //tODO
d71 1
a71 1
int net_connect(int ip,short port) {
d82 1
a82 1
 net_add_sock(s,client_socket);
d88 1
a88 1
int net_listen(int port) {
d99 1
a99 1
 if (bind(s,&ad,sizeof(ad))!=0) {
d109 2
a110 1
 net_add_sock(s,server_socket);
d120 20
d142 13
a154 1
//TODO
@
