#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
#include "b_mem.h"
#include "b_math.h"
#include "b_fs.h"
#include "b_util.h"
#include "b_tex.h"
#include "b_map.h"
#include "b_gl.h"

#define model_set_materials(m) material_list_use((m)->matl,1)    //nastavi textury jako pouzivane (zvysi reference count)
#define model_unset_materials(m) material_list_use((m)->matl,-1) //nastavi textury jako nepouzivane (snizi reference count, 0=nepouzivano)

//#define texture_used(m,t) t->refcount++
#define model_material_used(m,t) mat_list_addmaterial(&((m)->matl),t) //prida texturu do modelu jakozto pouzitou

// alternativni zacatek facu(primo jmeno textury)
#define model_face_begin(m,r,g,b,alpha,texname) model_face_begin_id(m,r,g,b,alpha,b_loadtexture(texname))
