/*** sound subsystem */
#include "bilbo.h"
#include "b_config.h"
#include "b_math.h"
#include "b_util.h"
#include "b_fs.h"
#include "b_mem.h"
#include "b_gl.h"

#ifdef have_sound
#include <AL/al.h>
#include <AL/alut.h>

typedef struct {//Zvukova data v pameti
 void *mem;//zvukova data v pameti
 ALuint buffer;//OpenAL sound buffer
 ALenum format;//sound format - mono/stereo, 8/16 bits
 uint freq;//samplovaci frekvence
 uint size;//velikost dat (v bajtech)
 ALboolean loop;//looping
} sound;

#endif