#include <stdlib.h>
#include <time.h>
#include "b_config.h"
#include "b_types.h"

//binarni vyhledavaci strom. Jako klic je pouzit retezec, obsahuje hodnoty typu (void *)
typedef struct _tree {
 int num;		//pocet prvku tohoto (pod)stromu
 char *name;		//jmeno
 void *val;		//hodnota
 struct _tree *l,*r;    //levy a pravy podstrom
} tree;

typedef void tree_func(char *name,void *s);
typedef void tree_func_p(char *name,void *s,void *param);

#define token_move(t,i) (t)->left-=i;(t)->curr+=i //posune kurzor v tokenu t o i mist dale
#define token_beginwith(t,w) (((t)->left>0) && (t)->curr[0]==(w)) //prvni znak tokenu
#define token_whitespace(t) (((t)->left>0) && isseparator((t)->curr[0])) //prvni znak tokenu
#define token_readkv(t,k,v) token_readkv_sep(t,k,v,'=') //makro na token_readkv_sep s defaultnim separatorem
#define token_create_dynamic(t,source,size) (t)=malloc1(sizeof(text_token));(t)->begin=(t)->curr=source;(t)->left=(size)

#define modelname(m) ((m)?((m)->manager?(m)->manager->name:"(noname)"):"--")//vypis jmena modelu
#define classname(o) ((o)->type?(o)->type->classname:"--")//vypis jmena tridy

#define eol(t) ((t)=='\r' || (t)=='\n' || (t)==0)// konec tadky
