#!/usr/bin/perl

$lang=$ARGV[0];
if ($lang=~/c/i) {
 $lang='cz';
 $title='Funkce a vlastnosti objekt - pehled';
 # TODO: dodelat, ted to nefunguje vubec
 $fde{"AI_CREATE"}="Konstruktor";
 $fde{"AI_DESTROY"}="Destruktor";
 $fde{"AI_DAMAGE"}="Funkce&nbsp;pokozen";
 $fde{"AI_TIMER"}="Funkce timeru";
 $fde{"AI_TOUCH"}="Funkce dotyku";
 $none="<font color=red>NIC</font>";
 $thead="<td>Funkce</td><td>Typ</td><td>Popis</td>";
} else {
 $lang='en';
 $title='Entity functions and properties reference';
 # TODO: dodelat, ted to nefunguje vubec
 $fde{"AI_CREATE"}="Constructor";
 $fde{"AI_DESTROY"}="Destructor";
 $fde{"AI_DAMAGE"}="Damage&nbsp;function";
 $fde{"AI_TIMER"}="Timer function";
 $fde{"AI_TOUCH"}="Touch function";
 $none="<font color=red>NONE</font>";
 $thead="<td>Function</td><td>Type</td><td>Description</td>";
}
print <<EOF;
<html><head><title>$title</title></head><link rel=stylesheet href=q.css>
<meta http-equiv="content-type" content="text/html; charset=windows-1250">
<body bgcolor=#000060 text=#ffffee link=#99ff99 vlink=#66ee66><h1>$title</h1>
<table><tr bgcolor=#0000ff>$thead</tr>
EOF
$cmt=$none;
sub xd {
 my ($t)=@_;
 @x=split (/\\/,$t);
 if ($lang eq 'cz') {
  if (@x>1) {
   return $x[1];
  } else {
   return "<font color=red>(!)</font> ".$x[0];
  }
 } else {
  return $x[0];
 }
}

while (<STDIN>) {
 s/[\r\n]+//g;
 if (/^\/\*\*(.*?)\*\//) {
  $cmt=$1;
 }
 if (/ai_result ([a-zA-Z_]+)\(([A-Z_]+)\)/) {
  $head=1;
  $name=$1;
  $typ=$2;
  $nop=1;
 }
 if (/.*?\/\/PROP:([^:]+):(.*)/i) {
  $prop=$1;
  $desc=xd($2);
 } elsif (/.*"([^"]+)"\s*,\s*([a-zA-Z0-9\.\-]+).*\/\/PROP::(.*)/i) {
  $prop=$1;
  $desc=xd($3)." (default: <u>$2</u>)";
 } elsif (/.*"([^"]+)".*\/\/PROP::(.*)/i) {
  $prop=$1;
  $desc=xd($2);
 } elsif (/\/\/PROP/i) {
  printf "<!--Unrecognized: $_-->";
 }
 if ($head) {
  $head=0;
  if ($fde{$typ}) {$typ=$fde{$typ};}
  $v=" valign=top";
  print "<tr><td$v><b>$name</b></td><td$v>$typ</td><td$v>$cmt</td></tr>\n";
  $cmt=$none;
 }
 if ($prop) {
  $v=" valign=top";
  if ($nop) {
   $nopp="properties:";$nop=0;
  } else {
   $nopp="&nbsp;";
  }
  print "<tr><td$v align=right>$nopp</td><td$v><font color=#ffff00>$prop</font></td><td$v>$desc</td></tr>\n";
  $prop=0;
 }
}
print <<EOF;
</table>
</body></html>
EOF
