/*** Pokusny testovaci program na experimenty s maticemi */
#ifdef _WIN32
#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )
#pragma comment( lib, "glut32.lib" )

#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>

/** vezme z OpenGL aktivni matici a vytiskne ji na stdout */
void printmat() {
 GLdouble m[16];
 int i;
 glGetDoublev(GL_MODELVIEW_MATRIX,m);//vezme aktualni matici
 printf("--\n");
 for (i=0;i<4;i++)
 printf("%4g %4g %4g %4g\n",m[i],m[i+4],m[i+8],m[i+12]);
}

/** main */
int main(int argc,char** argv){
 glutInit(&argc,argv);
 glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 glutInitWindowSize(100,100);
 glutInitWindowPosition(0,0);
 glutCreateWindow("?");
 printf("OpenGl version: %s\n",glGetString(GL_VERSION));
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
 glScalef(2,3,4);
 glTranslatef(5,6,7);
 printmat();
 glRotatef(1,1,1,90);
 printmat();
 return 0;
}
