head	1.34;
access;
symbols;
locks
	bilbo:1.34; strict;
comment	@ * @;


1.34
date	2003.05.19.01.47.01;	author bilbo;	state Exp;
branches;
next	1.33;

1.33
date	2003.05.15.00.55.51;	author bilbo;	state Exp;
branches;
next	1.32;

1.32
date	2003.05.12.00.57.26;	author bilbo;	state Exp;
branches;
next	1.31;

1.31
date	2003.05.10.18.58.47;	author bilbo;	state Exp;
branches;
next	1.30;

1.30
date	2003.05.10.13.50.12;	author bilbo;	state Exp;
branches;
next	1.29;

1.29
date	2003.05.04.01.02.44;	author bilbo;	state Exp;
branches;
next	1.28;

1.28
date	2003.04.27.02.15.08;	author bilbo;	state Exp;
branches;
next	1.27;

1.27
date	2003.04.19.14.38.00;	author bilbo;	state Exp;
branches;
next	1.26;

1.26
date	2003.02.26.21.54.37;	author bilbo;	state Exp;
branches;
next	1.25;

1.25
date	2003.02.26.19.21.41;	author bilbo;	state Exp;
branches;
next	1.24;

1.24
date	2003.02.19.22.08.45;	author bilbo;	state Exp;
branches;
next	1.23;

1.23
date	2003.02.18.01.27.53;	author bilbo;	state Exp;
branches;
next	1.22;

1.22
date	2003.02.17.12.26.55;	author bilbo;	state Exp;
branches;
next	1.21;

1.21
date	2003.02.17.00.25.28;	author bilbo;	state Exp;
branches;
next	1.20;

1.20
date	2003.02.15.15.38.26;	author bilbo;	state Exp;
branches;
next	1.19;

1.19
date	2003.02.15.14.09.47;	author bilbo;	state Exp;
branches;
next	1.18;

1.18
date	2003.01.28.00.55.50;	author bilbo;	state Exp;
branches;
next	1.17;

1.17
date	2003.01.27.17.49.07;	author bilbo;	state Exp;
branches;
next	1.16;

1.16
date	2003.01.19.02.52.53;	author bilbo;	state Exp;
branches;
next	1.15;

1.15
date	2003.01.12.12.20.14;	author bilbo;	state Exp;
branches;
next	1.14;

1.14
date	2003.01.11.19.53.38;	author bilbo;	state Exp;
branches;
next	1.13;

1.13
date	2003.01.10.01.09.58;	author bilbo;	state Exp;
branches;
next	1.12;

1.12
date	2003.01.06.01.39.24;	author bilbo;	state Exp;
branches;
next	1.11;

1.11
date	2003.01.03.01.50.00;	author bilbo;	state Exp;
branches;
next	1.10;

1.10
date	2002.12.27.01.57.08;	author bilbo;	state Exp;
branches;
next	1.9;

1.9
date	2002.12.23.12.35.24;	author bilbo;	state Exp;
branches;
next	1.8;

1.8
date	2002.12.23.01.24.34;	author bilbo;	state Exp;
branches;
next	1.7;

1.7
date	2002.12.15.22.38.40;	author bilbo;	state Exp;
branches;
next	1.6;

1.6
date	2002.12.15.21.47.41;	author bilbo;	state Exp;
branches;
next	1.5;

1.5
date	2002.12.15.20.34.40;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2002.12.15.18.29.58;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2002.12.15.17.49.51;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2002.12.06.00.02.53;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2002.12.03.22.55.35;	author bilbo;	state Exp;
branches;
next	;


desc
@prace s 3d modely
@


1.34
log
@*** empty log message ***
@
text
@/***
 funkce pro praci s 3d modely
*/

int fatal_loading_error; //pokud je 0, vse je v poradku, jinak to znamena ze pri nahravani neceho (typicky mapy) doslo k chybe...

//forward
model3d *model_txt_load(const char *name);
void world_destroyobject(object3d *o);

//World funkce

/** vytvori prazdny svet a naalokuje misto pro obj dynamickych objektu */
worldspawn *world_empty(int obj) {
 worldspawn *w;
 w=malloc0(sizeof(worldspawn));
 w->obj.alocobj=obj;
 w->obj.obj=malloc0(obj*sizeof(void*));
 debug_printf0("allocated %d, size %d\n",w->obj.obj,obj*sizeof(void*));
 return w;
}

/** odalokuje v pameti object class
 (zde pouze snizi pocet referenci, k skutecne odalokaci dojde pozdeji,
 az pri zavolani garbage collectoru - typicky po nahrani dalsiho levelu
 se odstani ty veci co v tom levelu nejsou. Tohle bude chtit jeste doresit) */
void freeobjectclass(objectclass *c) {
 exist_or_return(c,"freeobjectclass");//objekty bez class by se vyskytovat nemely
 c->refcount--;
 //TODO: nepouzivane objekty (refcount==0) se seberou nakonci levelu
}

/** odalokuje v pameti properties */
void freeproperties(properties *p) {
 properties *p2;
 while (p) { 
  free(p->k);
  free(p->v);
  p2=p->next;
  free(p);
  p=p2;
 }
}

/** odalokuje v pameti material list */
void freematlist(matlist *t) {
 matlist *q;
 while (t) {
  q=t->next;
  debug_printf0("freematlist: %s %d\n",t->t->name,t->t->ref);
  free(t);
  debug_printf0("freematlist: ok\n");
  t=q;
 }
}

/** odalokuje v pameti texture list */
void freetexlist(tex_list *t) {
 tex_list *q;
 while (t) {
  q=t->next;
  debug_printf0("freetexlist: %s %d\n",t->t->name,t->t->refcount);
  free(t);
  debug_printf0("freetexlist: ok\n");
  t=q;
 }
}


/** odalokuje v pameti linked list */
void freel_list(l_list *t) {
 l_list *q;
 while (t) {
  q=t->next;
  debug_printf0("freel_list: %d\n",t);
  free(t);
  debug_printf0("freel_list: ok\n");
  t=q;
 }
}

/** zduplikuje texture list */
matlist *dupmatlist(matlist *t) {
 matlist *q=0,*o=0;
 while (t) {
  if (o) {
   q->next=malloc1(sizeof(matlist));
   q=q->next;
  } else {
   o=malloc1(sizeof(matlist));
   q=o;
  }
  q->next=0;
  q->t=t->t;
  q->t->ref++;
  t=t->next;
 }
 return o;
}


#define model_set_materials(m) material_list_use((m)->matl,1)    //nastavi textury jako pouzivane (zvysi reference count)
#define model_unset_materials(m) material_list_use((m)->matl,-1) //nastavi textury jako nepouzivane (snizi reference count, 0=nepouzivano)

/** projde texturelist a u kazde textury v nem zvysi refcount (pocet pouziti) o r */
void material_list_use(matlist *t,int r) {
 while (t) {
  debug_printf0("texturelist_use:add %d to %s\n",r,t->t->name);
  t->t->ref+=r;
  t=t->next;
 }
}

/** odalokuje v pameti model */
void freemodel_real(model3d *m) {
 debug_printf0("freemodel_real:enter %d\n",m);
 if (!m) return; //objekty bez modelu jsou pomerne bezne, varovani by to hazet nemelo
 //exist_or_return(m,"freemodel");
 if (m->manager) {
  fatalf("DEBUG: freemodel_real: tyhle veci nemuzou jit pres manager!\n");
 }
 //TODO: nesnazit se o dealokaci tady, ael pozdeji udelat flush
 if (m->call_list) {
  glDeleteLists(m->call_list,1);
 }
 model_unset_materials(m);
 freematlist(m->matl);
 free(m->vert);
 free(m->facev);
 free(m->face);
 free(m);
 debug_printf0("freemodel_real:done\n");
}

void b_unloadmodel_r(char *name);//forward

/** odalokuje v pameti model - pokud na nej nejsou reference */
void freemodel(model3d *m) {
 debug_printf0("freemodel:enter %d\n",m);
 if (!m) return; //objekty bez modelu jsou pomerne bezne, varovani by to hazet nemelo
 //exist_or_return(m,"freemodel");
 if (m->manager) {
  debug_printf0("freemodel:use manager, refcount=%d\n",m->manager->refcount);
  if (!m->manager->name) {
   debug_printf("freemodel: null model name in manager!!! BUG!!!\n");
   return;
   //TODO: tohle bude v budoucnu celkem chyba!!!!
  }
  b_unloadmodel_r(m->manager->name);
  return;//model se pouziva, nelze odalokovat
 }
 //TODO: nesnazit se o dealokaci tady, ale pozdeji udelat flush
 freemodel_real(m);
 debug_printf0("freemodel:done\n");
}

void freeobject(object3d *o);//forward definice

/** odalokuje seznam objektu (jeden po druhem */
void freeobjectlist(objectlist o) {
// object3d **q;
 int i;
 debug_printf0("freeobjectlist:enter %d\n",o.numobj);
// q=o.obj;
 for (i=0;i<o.numobj;i++) {
  debug_printf0(" freeobjectlist:one %d\n",i);
  freeobject(o.obj[i]);//*q
//  q++;
 }
 debug_printf0(" freeobjectlist:want to free list %d\n",o.obj);
 free(o.obj);
 debug_printf0("freeobjectlist:done\n");
}

/** odalokuje objekt vcetne podrazenych stuktur a child objektu. Neodalokuje ale parent */
void freeobject(object3d *o) {
 debug_printf0("freeobject:enter %d\n",o);
 exist_or_return(o,"freeobject");
#ifdef use_odelib
 world_destroyobject(o);
#endif
 freeobjectclass(o->type);
 freeproperties(o->prop);
 freeobjectlist(o->child);
 freemodel(o->model);
 free(o);
 debug_printf0("freeobject:done\n");
}

/** odalokuje cely svet */
void freeworld (worldspawn *w) {
 debug_printf0("freeworld:enter %d\n",w);
 exist_or_return(w,"freeworld");
 debug_printf0("freeworld:before freemodel %d\n",w);
 freemodel(w->m);
 debug_printf0("freeworld:before freeobjectlist %d\n",w);
 freeobjectlist(w->obj);
 debug_printf0("freeworld:before exit %d\n",w);
 free(w);
 debug_printf0("freeworld:done\n");
}

//Funkce na zachazeni s tmpmodely

/** vytvori docasny (pametove neefektivni, ale rychly) model */
tmpmodel *model_begin(void) {
 tmpmodel *q;
 q=malloc0(sizeof(tmpmodel));
 q->maxvert=100;//TODO: odzkouset s jinymi hodnotami a dat jen nastavitelne
 q->maxface=100;
 q->maxpoint=100;
 q->p=malloc0(q->maxpoint*sizeof(facecoord));
 q->v=malloc0(q->maxvert*sizeof(vertex));
 q->f=malloc0(q->maxface*sizeof(modelface));
 return q;
}

//#define texture_used(m,t) t->refcount++
#define model_material_used(m,t) mat_list_addmaterial(&((m)->matl),t) //prida texturu do modelu jakozto pouzitou

/** prida material do seznamu */
void mat_list_addmaterial(matlist **m,material *tex) {
 matlist *t=*m;
 while (t) {
  if (t->t==tex) return; //textura tam jiz je
  t=t->next;
 }
 if (!t) {//zadne textury -> pridat
  t=*m;
  *m=malloc0(sizeof(matlist));
  (*m)->t=tex;
  (*m)->next=t;
 }
}

/** prida tex do linked listu */
void l_list_add(l_list **m,void *tex) {
 l_list *t=*m;
 while (t) {
  if (t->t==tex) return; //textura tam jiz je
  t=t->next;
 }
 if (!t) {//zadne textury -> pridat
  t=*m;
  *m=malloc0(sizeof(l_list));
  (*m)->t=tex;
  (*m)->next=t;
 }
}


//TODO: material manager

/** vytvori material s danymi parametry a nastavi reference count na 1 */
material *mat_create(byte r,byte g,byte b,byte alpha,texture *texture1) {
 material *m=malloc0(sizeof(material));
 m->color[0]=r;
 m->color[1]=g;
 m->color[2]=b;
 m->color[3]=alpha;
 m->tex=texture1;
 if (texture1) texture1->refcount++;
 m->ref=0;
 return m;
}

/** odalokuje material, pokud uz na nej nikde nic neukazuje */
void mat_free(material *m) {
 m->ref--;
 if (m->ref<=0) {
  if (m->tex) m->tex->refcount--;//todo: maybe free/flush
  if (m->name) free(m->name);//jemno materialu
  free(m);
 }
}

/** zacatek facu */
void model_face_begin_mat(tmpmodel *m, material *mat) {
 int i=m->numface;
 if (i==m->maxface) {
  m->maxface*=2;
  m->f=realloc1(m->f,m->maxface*sizeof(modelface));
 }
 m->f[i].m=mat;
 if (mat) model_material_used(m,mat);
 m->f[i].ncoord=0;
 m->numface++;
}

/** zacatek facu */
void model_face_begin_id(tmpmodel *m, byte r,byte g,byte b,byte alpha,texture *texture1) {
 material *mat=mat_create(r,g,b,alpha,texture1);
 model_face_begin_mat(m,mat);
}

// alternativni zacatek facu(primo jmeno textury)
#define model_face_begin(m,r,g,b,alpha,texname) model_face_begin_id(m,r,g,b,alpha,b_loadtexture(texname))

/** prida vertex do modelu (pokud tam uz neni), vrati jeho cislo. Cisla tvori posloupnost, pocinaje nulou */
int model_addvertex(tmpmodel *m,bfloat x1,bfloat y1,bfloat z1,int check_if_already_exist){
 int j,i=m->numvert;
 if (check_if_already_exist) {
  for (j=0;j<i;j++) {//test jestli tam uz vertex neni
   //TODO: tohle chce HODNE zlepsit. staci malo vertexu a uz je to rychlostne v prdcicich, pac je to n^2
   //TODO: pri n vertexech je to n^2, chci n*log n (BVS)
   //TODO: asi by to byl binarni vyhledavaci strom podle x+y+z (nebo x,y,z)
   if (m->v[j].x==x1 && m->v[j].y==y1 && m->v[j].z==z1 ) return j; //recyklace vertexu
  }
 }
 if (i==m->maxvert) {//test velikosti pole 
  m->maxvert*=2;
  m->v=realloc1(m->v,m->maxvert*sizeof(vertex));
 }
 m->v[i].x=x1;//pridani vertexu
 m->v[i].y=y1;
 m->v[i].z=z1;
 m->numvert++;
 return i;
}

/** prida vertex podle cisla - nutno nejdriv pridat vertexu cislo pres model_addvertex */
void model_vertex_num(tmpmodel *m,bfloat tex_x,bfloat tex_y,int vnum) {
 int i=m->numface-1;// aktualni face
 int np=m->numpoint;
 m->f[i].ncoord++; //pocet vertexu v aktualnim facu
 if (np==m->maxpoint) {
  m->maxpoint*=2;
  m->p=realloc1(m->p,m->maxpoint*sizeof(facecoord));
 }
 m->p[np].n=vnum;
 m->p[np].u=tex_x;
 m->p[np].v=tex_y;
 m->numpoint++;
}

/** prida vertex podle souradnic */
void model_vertex(tmpmodel *m,bfloat tex_x,bfloat tex_y,bfloat x,bfloat y,bfloat z) {
 int vnum=model_addvertex(m,x,y,z,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** prida vertex (podle souradnic) */
void model_vertexv(tmpmodel *m,bfloat tex_x,bfloat tex_y,vertex v) {
 int vnum=model_addvertex(m,v.x,v.y,v.z,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** prida vertex (podle souradnic, se scalovanim) */
void model_vertexvs(tmpmodel *m,bfloat tex_x,bfloat tex_y,vertex v,bfloat scale) {
 int vnum=model_addvertex(m,v.x*scale,v.y*scale,v.z*scale,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** konec facu: normala dana vektorem */
void model_face_end_v(tmpmodel *m,vector normal) {
 m->f[m->numface-1].normal=normal;
}

/** konec facu: normala se spocita automaticky*/
void model_face_end(tmpmodel *m) {
 vector normal={0,0,0};
 int i=m->numface-1;// aktualni face
 int nc=m->f[i].ncoord;
 if (nc>2) { //z prvnich 3 vektoru udela normalu
  int np=m->numpoint-nc;
  normal=v_mulv(v_sub(m->v[m->p[np+2].n],m->v[m->p[np+1].n]),v_sub(m->v[m->p[np+1].n],m->v[m->p[np].n]));
  normalize(&normal);
 }
// debug_printf0("model_face_end : normal = %g %g %g\n",all3d(normal));
 model_face_end_v(m,normal);
}

/** nastavi na axis-aligned bounding boxu do souradni + a - nekonecno */
void abox_inf(aa_bbox *b) {
 b->lo.x=b->lo.y=b->lo.z=finf;
 b->hi.x=b->hi.y=b->hi.z=-finf;
}

/** vynujuje axis-aligned bounding box */
void abox_null(aa_bbox *b) {
 zerov(b->lo);
 zerov(b->hi);
}

/** vrati aa-bbox dane velikosti (<-x -x -x> - <+x +x +x>) */
aa_bbox abox_x(bfloat x) {
 aa_bbox b;
 b.lo.x=b.lo.y=b.lo.z=-x;
 b.hi.x=b.hi.y=b.hi.z=x;
 return b;
}

/** prida vertex do bounding boxu */
void abox_addvertex(aa_bbox *a,vertex v) {
 if (v.x>a->hi.x) a->hi.x=v.x;
 if (v.y>a->hi.y) a->hi.y=v.y;
 if (v.z>a->hi.z) a->hi.z=v.z;
 if (v.x<a->lo.x) a->lo.x=v.x;
 if (v.y<a->lo.y) a->lo.y=v.y;
 if (v.z<a->lo.z) a->lo.z=v.z;
}

/** spocita bounding box modelu */
void model_calculate_abox(model3d *mo) {
 int q;
 debug_printf0("Adding %d vertexes to abox\n",mo->nvert);
 if (mo->nvert) {
  abox_inf(&mo->abox);
  for (q=0;q<mo->nvert;q++) { //calculate bounding box
   abox_addvertex(&mo->abox,mo->vert[q]);
  }
 } else {
  abox_null(&mo->abox);
 }
}

/** axis-aligned bounding box je vynasobena o vektor scale */
void abox_scale_v(aa_bbox *a,const vector scale) {
 a->hi.x*=scale.x;
 a->lo.x*=scale.x;
 a->hi.y*=scale.y;
 a->lo.y*=scale.y;
 a->hi.z*=scale.z;
 a->lo.z*=scale.z;
}

/** axis-aligned bounding box je vynasobena o konstantu scale */
void abox_scale(aa_bbox *a,const bfloat scale) {
 a->hi.x*=scale;
 a->lo.x*=scale;
 a->hi.y*=scale;
 a->lo.y*=scale;
 a->hi.z*=scale;
 a->lo.z*=scale;
}

/** axis-aligned bounding box je posunuta o vektor polohy */
void abox_move_v(aa_bbox *a,const vector p) {
 a->hi.x+=p.x;
 a->lo.x+=p.x;
 a->hi.y+=p.y;
 a->lo.y+=p.y;
 a->hi.z+=p.z;
 a->lo.z+=p.z;
}

/** vrati axis-aligned bounding box posunutou o vektor polohy */
aa_bbox abox_move(aa_bbox *a,const vector p) {
 aa_bbox e;
 e.hi.x=a->hi.x+p.x;
 e.lo.x=a->lo.x+p.x;
 e.hi.y=a->hi.y+p.y;
 e.lo.y=a->lo.y+p.y;
 e.hi.z=a->hi.z+p.z;
 e.lo.z=a->lo.z+p.z;
 return e;
}

/** presune vsechny vertexy v modelu o (ix,iy,iz) - move */
void model_move(model3d *mo,bfloat ix,bfloat iy,bfloat iz) {
 int i;
 vector iv;
 for (i=0;i<mo->nvert;i++) {
  mo->vert[i].x+=ix;
  mo->vert[i].y+=iy;
  mo->vert[i].z+=iz;
 }
 iv.x=ix;iv.y=iy;iv.z=iz;
 abox_move_v(&mo->abox,iv);
}

/** vynasobi vsechny vertexy v modelu (ix,iy,iz) - scale */
void model_scale(model3d *mo,bfloat ix,bfloat iy,bfloat iz) {
 int i;
 vector iv;
 for (i=0;i<mo->nvert;i++) {
  mo->vert[i].x*=ix;
  mo->vert[i].y*=iy;
  mo->vert[i].z*=iz;
 }
 iv.x=ix;iv.y=iy;iv.z=iz;
 abox_scale_v(&mo->abox,iv);
}

/** vyrobi finalni 3d model z docasneho modelu */
model3d *model_end(tmpmodel *m) {
 int fi,fo,fpi,fpo,q;
 model3d *mo;//vystupni model
 mo=malloc0(sizeof(model3d));
 //vertexes
 mo->nvert=m->numvert;
 mo->vert=malloc1(mo->nvert*sizeof(vertex));
 memmove(mo->vert,m->v,mo->nvert*sizeof(vertex));
 //face points
 mo->nfacev=m->numpoint;
 mo->facev=malloc1(mo->nfacev*sizeof(facecoord));
 //faces
 mo->nface=m->numface;
 mo->face=malloc1(mo->nface*sizeof(modelface));
// stary kod - netridil na transparentni a netransparentni
// memmove(mo->facev,m->p,mo->nfacev*sizeof(facecoord));
// memmove(mo->face,m->f,mo->nface*sizeof(modelface));

 //move facepoints and faces
 fpo=0;fo=0;
 for (fpi=0,fi=0;fi<m->numface;fi++) {//for each face
  if (m->f[fi].m->color[3]==255) {
   mo->face[fo]=m->f[fi];
   mo->face[fo].m->ref++;//refcount u materialu
   fo++;
   for (q=0;q<m->f[fi].ncoord;q++) {
    mo->facev[fpo+q]=m->p[fpi+q];
   }
   fpo+=m->f[fi].ncoord;
  }
  fpi+=m->f[fi].ncoord;
 }
 debug_printf0("model_end: !pi=%d po=%d\n",fpi,fpo);
 debug_printf0("model_end: !fi=%d fo=%d\n",fi,fo);
 for (fpi=0,fi=0;fi<m->numface;fi++) {//for each face
  if (m->f[fi].m->color[3]!=255) {
   mo->face[fo]=m->f[fi];
   mo->face[fo].m->ref++;//refcount u materialu
   fo++;
   for (q=0;q<m->f[fi].ncoord;q++) {
    mo->facev[fpo+q]=m->p[fpi+q];
   }
   fpo+=m->f[fi].ncoord;
  }
  fpi+=m->f[fi].ncoord;
 }
 debug_printf0("model_end: pi=%d po=%d (%d)\n",fpi,fpo);
 debug_printf0("model_end: fi=%d fo=%d (%d)\n",fi,fo);

 model_calculate_abox(mo);
 //texture list
 mo->matl=dupmatlist(m->matl);
 model_set_materials(mo);
 return mo;
}

//TODO: multithread: behem nahravani modelu (model_begin/model_end) nesmi prijit flush textur ci materialu (zatim to nevadi)

/** vycisti model, ale neuvolni pamet. dobre pokud chcem hned delat dalsi model */
void model_clear(tmpmodel *m) {
 m->numvert=m->numface=m->numpoint=0;
 freematlist(m->matl);
 m->matl=0;
}

/** uvolni model z pameti */
void model_free(tmpmodel *m) {
 model_unset_materials(m);//zlikvidovat materialy
 if (m->matl) freematlist(m->matl);//zlikvidovat material list
 if (m->p) free(m->p);
 if (m->v) free(m->v);
 if (m->f) free(m->f);
 free(m);
}


//MODEL MANAGER

tree *model_tree; // strom s nahranymi modely
model3d *failsafemodel;//model pouzity pokud neni zadany model k dispozici (muze byt i NULL)

model3d *model_map_load(const char *name);//forward

/** Nahraje model z disku do pameti, typ modelu se vezme dle pripony */
model *fs_loadmodel(const char *name) {
 model3d *m;
 model *mo;
 char *nameplus;
 char *name2;
 debug_printf("Loading model: %s ->",name);
 name2=str_plus("models/",name);
 debug_printf("%s\n",name2);
 //autodetekce modelu podle extension
 if (str_endwithi(name,".map")) m=model_map_load(name2);
 else if (str_endwithi(name,".txt")) m=model_txt_load(name2);
 else { /// bez extension, zkusi priplacavat ruzne extensions a model nahravat jako ruzne typy
  debug_printf("No ext found: %s\n",name);
  nameplus=str_plus(name2,".txt");
  m=model_txt_load(nameplus);
  str_free(nameplus);
  if (!m) { // mpredchozi ty se nenahral, zkusim dalsi
   nameplus=str_plus(name2,".map");
   m=model_map_load(nameplus);//.map az v nejvyssi nouzi
   str_free(nameplus);
  }
 }
 str_free(name2);
 debug_printf("Model found as: %d\n",m);
 if (!m) m=failsafemodel;
 mo=malloc0(sizeof(model));
 mo->mem=m;
 mo->name=strdup(name);
 return mo;
}

/** Uvolni nahrany model z pameti */
void fs_unloadmodel(model *ou) {
 if (ou->mem!=failsafemodel && ou->mem) {// z failsafe se bere vzdy jen odkaz na pamet.
  ou->mem->manager=0;
  freemodel_real(ou->mem);
 }
 free(ou->name);
 free(ou);
}

/**  nahraje model s danym jmenem a zaradi ho do seznamu nahranych modelu
  Pokud je v pameti tak misto nahravani rovnou vrati pointer.
  Muze vratit i null (prazdny model)
*/
model *b_loadmodel_internal(char *name) {
 model *tg;
 debug_printf("[ModelMan] %s requested\n",name);
 tg=tree_search(model_tree,name);
 if (tg) return tg; //model je jiz v pameti, netreba nahravat
 tg=fs_loadmodel(name);
 debug_printf0("[ModelMan] %s loaded\n",name);
 tree_add(&model_tree,name,tg);
 if (tg->mem) { 
  tg->mem->manager=0;
 }
 return tg;
}

/**  podiva se po modelu s danym jmenem v pameti a pokud tam je, tak ho odstrani*/
void b_unloadmodel(char *name) {
 model *tg=tree_search(model_tree,name);
 if (!tg) return; //model jiz neni v pameti
 tree_del(&model_tree,name);
 fs_unloadmodel(tg);
}

/** zavola b_loadmodel_internal a zvysi usage counter
*/
model3d *b_loadmodel_r(char *name) {
 model *r=b_loadmodel_internal(name);
 if (r) {
  r->refcount++;
  if (r->mem) r->mem->manager=r;
 }
 debug_printf0("b_loadmodel_r: return %d\n",r->mem);
 return r->mem;
}

/** quick hack - nahraje model a pak ho scaluje a posunuje - nyni neni pouzivano */
model3d *b_loadmodel_r_trans(char *name,bfloat tx,bfloat ty,bfloat tz,bfloat sx,bfloat sy,bfloat sz) {
 model3d *r=b_loadmodel_r(name);
 if (r && r->manager && r->manager->refcount==1) {//prave nahrany
  model_move(r,tx,ty,tz);
  model_scale(r,sx,sy,sz);
 }
 return r;
}


/** zavola b_loadmodel_internal a nezvysi usage counter
*/
model3d *b_loadmodel(char *name) {
 return b_loadmodel_internal(name)->mem;
}

/**  podiva se po modelu s danym jmenem v pameti a pokud tam je, tak ji snizi reference count. Pokud je 0, tak je odstranen z pameti */
void b_unloadmodel_r(char *name) {
 model *tg=tree_search(model_tree,name);
 if (!tg) return; //jiz neni v pameti
 tg->refcount--;
 if (tg->refcount) return;// stale je pouzivan
 tree_del(&model_tree,name);
 fs_unloadmodel(tg);
}

/** vnitri callback funkce model_flush (pridani do seznamu) */
void _model_flush(char *name,model *t,l_list **l) {
 if (t->refcount<0) {
  fatalf("_model_flush: negative refcount (%s,%d)\n",t->name,t->refcount);
 }
 if (t->refcount) return;
 l_list_add(l,t);
 unused(name);
}

/** odstrani z pameti modely co nejsou pouzivany (refcount=0) */
void model_flush() {
 l_list *t=0,*p;
 tree_foreach_p(model_tree,_model_flush,&t);//nalezeni vsech nepouzitych a pridani do seznamu
 p=t;
 while(p) {//likvidace obsahu seznamu
  debug_printf0("removing %s:%d\n",((model *)(p->t))->name,((model *)(p->t))->refcount);
  b_unloadmodel(((model *)(p->t))->name);
  p=p->next;
 }
 freel_list(t);//likvidace seznamu
}

@


1.33
log
@*** empty log message ***
@
text
@d645 1
a645 1
 debug_printf("b_loadmodel_r: return %d\n",r->mem);
@


1.32
log
@*** empty log message ***
@
text
@d9 1
d179 3
@


1.31
log
@*** empty log message ***
@
text
@d7 3
d44 12
d57 2
a58 2
void freetexlist(texlist *t) {
 texlist *q;
d68 1
d82 2
a83 2
texlist *duptexlist(texlist *t) {
 texlist *q=0,*o=0;
d86 1
a86 1
   q->next=malloc1(sizeof(texlist));
d89 1
a89 1
   o=malloc1(sizeof(texlist));
d94 1
d101 2
a102 2
#define model_settextures(m) texturelist_use((m)->texl,1)    //nastavi textury jako pouzivane (zvysi reference count)
#define model_unsettextures(m) texturelist_use((m)->texl,-1) //nastavi textury jako nepouzivane (snizi reference count, 0=nepouzivano)
d105 1
a105 1
void texturelist_use(texlist *t,int r) {
d108 1
a108 1
  t->t->refcount+=r;
d125 2
a126 2
 model_unsettextures(m);
 freetexlist(m->texl);
d215 1
a215 1
#define model_texture_used(m,t) tex_list_addtexture(&((m)->texl),t) //prida texturu do modelu jakozto pouzitou
d217 3
a219 3
/** prida texturu do texturelistu */
void tex_list_addtexture(texlist **m,texture *tex) {
 texlist *t=*m;
d226 1
a226 1
  *m=malloc0(sizeof(texlist));
d247 26
d274 1
a274 1
void model_face_begin_id(tmpmodel *m, byte r,byte g,byte b,byte alpha,texture *texture1) {
d280 2
a281 6
 m->f[i].tex_color[0]=r;
 m->f[i].tex_color[1]=g;
 m->f[i].tex_color[2]=b;
 m->f[i].tex_color[3]=alpha;
 m->f[i].texture=texture1/*->id*/;
 if (texture1) model_texture_used(m,texture1);
d286 6
d375 1
a375 1
/** vynujuje axis-alignes bounding box */
d503 1
a503 1
  if (m->f[fi].tex_color[3]==255) {
d505 1
d517 1
a517 1
  if (m->f[fi].tex_color[3]!=255) {
d519 1
d533 2
a534 2
 mo->texl=duptexlist(m->texl);
 model_settextures(mo);
d538 2
d543 2
a544 2
 freetexlist(m->texl);
 m->texl=0;
d549 2
a550 1
 if (m->texl) freetexlist(m->texl);
@


1.30
log
@*** empty log message ***
@
text
@d520 4
d525 2
a526 2
 if (str_endwithi(name,".map")) m=model_map_load(name);
 else if (str_endwithi(name,".txt")) m=model_txt_load(name);
d528 2
a529 1
  nameplus=str_plus(name,".txt");
d532 5
a536 3
  nameplus=str_plus(name,".map");
  m=model_map_load(nameplus);//.map az v nejvyssi nouzi
  str_free(nameplus);
d538 2
@


1.29
log
@*** empty log message ***
@
text
@d515 1
a515 1
/** Uvolni nahrany model z pameti */
d517 1
a517 1
 model3d *m=model_map_load(name);
d519 12
a530 2
 //TODO: tady bude na vyber vice formatu ve vice adresarich, atd ...
 //TODO: vyber pripon podobne jako ve fs_loadtexture
@


1.28
log
@*** empty log message ***
@
text
@d33 1
@


1.27
log
@*** empty log message ***
@
text
@d575 1
a575 1
/** quick hack - nahraje model a pak ho scaluje a posunuje */
@


1.26
log
@*** empty log message ***
@
text
@d344 1
a344 1
void add_to_abox(aa_bbox *a,vertex v) {
d360 1
a360 1
   add_to_abox(&mo->abox,mo->vert[q]);
@


1.25
log
@*** empty log message ***
@
text
@d24 1
a24 2
 if (!c) return; //objekty bez classy nedelaji nic. TODO: to by se v budoucnosti stavat nemelo, minimalne bude kazdy alespon func_wall nebo tak nejak
 //exist_or_return(c,"freeobjectclass");
a253 1
   //TODO  
@


1.24
log
@*** empty log message ***
@
text
@d379 10
@


1.23
log
@*** empty log message ***
@
text
@d326 1
a326 1
void bbox_inf(aa_bbox *b) {
d332 1
a332 1
void bbox_null(aa_bbox *b) {
d338 1
a338 1
aa_bbox bbox_x(bfloat x) {
d356 1
a356 1
void model_calculate_bbox(model3d *mo) {
d358 1
a358 1
 debug_printf0("Adding %d vertexes to bbox\n",mo->nvert);
d360 1
a360 1
  bbox_inf(&mo->abox);
d365 1
a365 1
  bbox_null(&mo->abox);
d369 31
d404 1
d410 2
d417 1
d423 2
d475 1
a475 1
 model_calculate_bbox(mo);
@


1.22
log
@*** empty log message ***
@
text
@d126 5
@


1.21
log
@*** empty log message ***
@
text
@d5 2
@


1.20
log
@*** empty log message ***
@
text
@d13 1
a13 1
 debug_printf("allocated %d, size %d\n",w->obj.obj,obj*sizeof(void*));
d96 1
a96 1
 debug_printf("freemodel_real:enter %d\n",m);
d112 1
a112 1
 debug_printf("freemodel_real:done\n");
d119 1
a119 1
 debug_printf("freemodel:enter %d\n",m);
d123 1
a123 1
  debug_printf("freemodel:use manager, refcount=%d\n",m->manager->refcount);
d129 1
a129 1
 debug_printf("freemodel:done\n");
d491 1
a491 1
 debug_printf("[ModelMan] %s is needed\n",name);
d495 1
a495 1
 debug_printf("[ModelMan] %s loaded\n",name);
@


1.19
log
@*** empty log message ***
@
text
@d458 1
a458 1
model3d *failsafemodel;
@


1.18
log
@*** empty log message ***
@
text
@d40 2
a41 2
void freetexlist(texturelist *t) {
 texturelist *q;
d51 12
d64 2
a65 2
texturelist *duptexlist(texturelist *t) {
 texturelist *q=0,*o=0;
d68 1
a68 1
   q->next=malloc1(sizeof(texturelist));
d71 1
a71 1
   o=malloc1(sizeof(texturelist));
d86 1
a86 1
void texturelist_use(texturelist *t,int r) {
d95 2
a96 2
void freemodel(model3d *m) {
 debug_printf0("freemodel:enter %d\n",m);
d99 4
d112 18
a129 1
 debug_printf0("freemodel:done\n");
d194 17
a210 2
void tex_list_addtexture(texturelist **m,texture *tex) {
 texturelist *t=*m;
d217 1
a217 1
  *m=malloc0(sizeof(texturelist));
d341 2
a342 2
 if (v.x>a->hi.y) a->hi.y=v.y;
 if (v.x>a->hi.z) a->hi.z=v.z;
d344 37
a380 2
 if (v.x<a->lo.y) a->lo.y=v.y;
 if (v.x<a->lo.z) a->lo.z=v.z;
d431 1
a431 8
 if (mo->nvert) {
  bbox_inf(&mo->abox);
  for (q=0;q<mo->nvert;q++) { //calculate bounding box
   add_to_abox(&mo->abox,mo->vert[q]);
  }
 } else {
  bbox_null(&mo->abox);
 }
d453 120
@


1.17
log
@*** empty log message ***
@
text
@d251 6
a256 1
/** konec facu */
d258 10
a267 2
 unused(m);
 //DO nothing
d282 18
d332 2
a333 2
 debug_printf0("!pi=%d po=%d\n",fpi,fpo);
 debug_printf0("!fi=%d fo=%d\n",fi,fo);
d345 2
a346 2
 debug_printf0("pi=%d po=%d (%d)\n",fpi,fpo);
 debug_printf0("fi=%d fo=%d (%d)\n",fi,fo);
d351 1
@


1.16
log
@*** empty log message ***
@
text
@d13 1
d44 1
d46 1
d76 1
a76 1
  debug_printf0("add %d to %s\n",r,t->t->name);
d84 1
d96 1
d103 1
a103 1
 object3d **q;
d105 6
a110 4
 q=o.obj;
 for (i=1;i<=o.numobj;i++) {
  freeobject(*q);
  q++;
d112 1
d114 1
d119 1
d126 1
d131 1
d133 1
d135 1
d137 1
d139 1
d334 1
d339 1
a339 1
 freetexlist(m->texl);
d343 1
a343 1
 if (m) free(m);
@


1.15
log
@*** empty log message ***
@
text
@d241 12
d255 1
a255 1
 int i,j,io,jo,fp;
d268 1
a268 3

 //move facepoints and faces
 //TODO: transparentni na konec
a269 1
 //TODO: transparentni na konec
d272 25
a296 3
 fp=0;
 for (i=0;i<mo->nface;i++) {//for each face
  mo->face[i]=m->f[i];
d298 9
a306 2
 for (j=0;j<mo->nfacev;j++) {//for each facepoint
  mo->facev[j]=m->p[j];
@


1.14
log
@*** empty log message ***
@
text
@d81 2
a82 1
 exist_or_return(m,"freemodel");
d243 1
a252 1
 memmove(mo->facev,m->p,mo->nfacev*sizeof(facecoord));
d256 15
a270 1
 memmove(mo->face,m->f,mo->nface*sizeof(modelface));
@


1.13
log
@*** empty log message ***
@
text
@d66 13
d85 1
d113 1
d141 1
a141 1
#define texture_used(m,t) _texture_used(&((m)->texl),t) //prida texturu do modelu jakozto pouzitou
d144 1
a144 1
void _texture_used(texturelist **m,texture *tex) {
a157 11
#define model_settextures(m) texturelist_use((m)->texl,1)    //nastavi textury jako pouzivane (zvysi reference count)
#define model_unsettextures(m) texturelist_use((m)->texl,-1) //nastavi textury jako nepouzivane (snizi reference count, 0=nepouzivano)

/** projde texturelist a u kazde textury v nem zvysi refcount (pocet pouziti) o r */
void texturelist_use(texturelist *t,int r) {
 while (t) {
  t->t->refcount+=r;
  t=t->next;
 }
}

d170 1
a170 1
 if (texture1) texture_used(m,texture1);
a268 1
 model_unsettextures(m);
@


1.12
log
@*** empty log message ***
@
text
@d166 1
a166 1
 texture_used(m,texture1);
@


1.11
log
@*** empty log message ***
@
text
@d21 2
a22 1
 exist_or_return(c,"freeobjectclass");
@


1.10
log
@*** empty log message ***
@
text
@d1 1
a1 1
/** 
@


1.9
log
@*** empty log message ***
@
text
@d217 12
@


1.8
log
@*** empty log message ***
@
text
@d174 1
a174 1
int model_addvertex(tmpmodel *m,float x1,float y1,float z1,int check_if_already_exist){
d197 1
a197 1
void model_vertex_num(tmpmodel *m,float tex_x,float tex_y,int vnum) {
d212 1
a212 1
void model_vertex(tmpmodel *m,float tex_x,float tex_y,float x,float y,float z) {
@


1.7
log
@*** empty log message ***
@
text
@d164 1
a164 1
 m->f[i].texture=texture1->id;
@


1.6
log
@*** empty log message ***
@
text
@d170 3
@


1.5
log
@*** empty log message ***
@
text
@d177 2
a178 1
   //TODO: asi by to byl binarni vyhledavaci strom podle x+y+z
@


1.4
log
@*** empty log message ***
@
text
@d124 28
a151 1
#define texture_used(m,t) t->refcount++ //todo: add to used in model instead
d236 1
d248 1
@


1.3
log
@*** empty log message ***
@
text
@d37 28
d107 118
@


1.2
log
@*** empty log message ***
@
text
@d43 1
@


1.1
log
@Initial revision
@
text
@d17 3
a19 1
 (zde pouze snizi pocet referenci, k skutecne odalokaci dojde pozdeji) */
@
