head	1.6;
access;
symbols;
locks
	bilbo:1.6; strict;
comment	@ * @;


1.6
date	2003.08.29.22.50.21;	author bilbo;	state Exp;
branches;
next	1.5;

1.5
date	2003.06.08.15.12.57;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2003.05.31.01.26.02;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.05.31.01.25.57;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.23.17.49.05;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.22.13.10.00;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.6
log
@*** empty log message ***
@
text
@/***
 funkce pro praci s texturami (hlavne nahravani)

*/
#include "config.h"
#include "b_tex.h"

texture *failsafetex;//defaultni textura		[EXT]
tree *tex_tree; // strom s nahranymi texturami		[EXT]
int tex_memory;//celkova pamet sezrana vsemi texturami	[EXT]

#ifndef only_console //[PASS]
/** nahraje texturu z pameti do pameti graficke karty, k texture navic vyrobi mipmapy */
void gl_loadtex(int num,int bpp,int x,int y,void *tex) {
#ifndef dedicated_server
 glPixelStorei(GL_UNPACK_ALIGNMENT,8);
 last_texture=0;//timhle nahravanim ji zrusime defacto ....
 glBindTexture(GL_TEXTURE_2D, num);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
 //glTexImage2D(GL_TEXTURE_2D,0,bpp,x,y,0,(bpp==3)?GL_RGB:GL_RGBA,GL_UNSIGNED_BYTE,tex);
 //TODO: kdyz tomu podstrcim neco co neni v powers-of-two tak to obcas sleti
 if (gluBuild2DMipmaps(GL_TEXTURE_2D,bpp,x,y,(bpp==3)?GL_RGB:GL_RGBA,GL_UNSIGNED_BYTE,tex))
 fatalf("gl_loadtex: Unable to build mipmaps for texture %d (x=%d, y=%d, bpp=%d)",num,x,y,bpp); 
#endif
}

/** nahraje texturu v pameti v .tga formatu do pameti graficke karty. Detaily viz loadtex */
void gl_loadtgatex(int num,tgafile *tex) {
#ifndef dedicated_server
 if (!tex) fatalf("gl_loadtgatex: Texture %d not loaded!",num);
 gl_loadtex(num,(tex->head.bpp)/8,tex->head.x,tex->head.y,&(tex->data[0]));
#endif
}
#endif //[PASS]

typedef struct { //struktura pro JPEGlib
 struct jpeg_source_mgr pub;	//vlastni data jpeglibu
 unsigned char *buffer;		//muj buffer v pameti
 int len;			//delka bufferu
} mem_src;

/** spec. funkce pro JPEGlib - nedela nic */
METHODDEF_void mem_nop(j_decompress_ptr cinfo){ unused(cinfo); }
/** spec. funkce pro JPEGlib - input buffer, nacte kus jpegu z pameti */
METHODDEF_boolean mem_input_buffer(j_decompress_ptr cinfo){
 mem_src *src=(mem_src *)cinfo->src;
 src->pub.next_input_byte=src->buffer;
 src->pub.bytes_in_buffer=src->len;
 return TRUE;
}
/** spec. funkce pro JPEGlib - skip input in buffer (jpeg v pameti) */
METHODDEF_void mem_skip_input(j_decompress_ptr cinfo, long n){
 mem_src *src=(mem_src *)cinfo->src;
 if (n>0) {
  src->pub.next_input_byte+=n;
  src->pub.bytes_in_buffer-=n;
 }
}

/** callback funkce pro JPEGlib - (jpeg v pameti) */
void jpeg_mem_src (j_decompress_ptr cinfo,void *mem,int mem_len) {
 mem_src *src;
 if (!cinfo->src) {
   cinfo->src=(*cinfo->mem->alloc_small)((j_common_ptr)cinfo,JPOOL_PERMANENT,sizeof(mem_src));
 }
 src=(mem_src *)cinfo->src;
 src->pub.init_source=mem_nop;
 src->pub.fill_input_buffer=mem_input_buffer;
 src->pub.skip_input_data=mem_skip_input;
 src->pub.resync_to_restart=jpeg_resync_to_restart;
 src->pub.term_source=mem_nop;
 src->buffer=mem;
 src->len=mem_len;
 //src->pub.bytes_in_buffer=0;
 //src->pub.next_input_byte=NULL;
 src->pub.next_input_byte=mem;
 src->pub.bytes_in_buffer=mem_len;
}

jmp_buf jm; //libjpeg mi nedava jinou moznost nez pouzit setjmp/longjmp
int jmret; //navratovy kod setjmp/jongjmp

/** callback funkce pro JPEGlib - vola se pokud je JPEG vadny .... */
METHODDEF(void) mem_exit (j_common_ptr cinfo) {
 (*cinfo->err->output_message)(cinfo);
 //TODO: hlaska jde na konzoli
 longjmp(jm,1);
}

/** nahraje jpg texturu a zkonvertuje do .tga textury,
 vrati velikost v bajtech vc. hlavicky a pokud neuspeje, vrati 0 a out je nastaven na NULL */
int fs_loadjpegfile(void **out,const char *name) {
 struct jpeg_decompress_struct cinfo;
 struct jpeg_error_mgr jerr;
 int num_scanlines=0;
 int x=0,y=0,bpp,in_file_bytes,ns;
 void *in;
 unsigned char *b;
 tgafile *buffer=0;
 in_file_bytes=fs_loadfile(&in,name);
 if (!in) { //soubor neexistuje, dosla pamet ci co ...
  *out=0;
  return 0;
 }
 if (!in_file_bytes) { // soubor je prazdny, cili totez. Na prazdne soubory se pamet nealokuje, takze nedojde k memory leaku (vrati to jen mrtvy pointer ukazujici do luftu)
  *out=0;
  return 0;
 }
 memset(&cinfo,sizeof(cinfo),0);
 memset(&jerr,sizeof(jerr),0);
 cinfo.err=jpeg_std_error(&jerr);//todo: jiny error handling!!!!!
 jerr.error_exit=mem_exit;
 jpeg_create_decompress(&cinfo);
 jpeg_mem_src(&cinfo,in,in_file_bytes);
 jmret=setjmp(jm);// je to prasarna ale jinak to s touhle knihovnou nejde :o(
 if(!jmret) {
 (void)jpeg_read_header(&cinfo, TRUE);
 (void)jpeg_start_decompress(&cinfo);
 x=cinfo.output_width;
 y=cinfo.output_height;
 bpp=cinfo.output_components;
 if (!(bpp==3 || bpp==4)) goto final;
 buffer=malloc1(x*y*bpp+sizeof(tgaheader));
 memset(buffer,sizeof(tgaheader),0);
 buffer->head.x=(short)x;
 buffer->head.y=(short)y;
 buffer->head.bpp=(byte)(bpp*8);
 //zbytek hlavicky nevyplnuji, pac ho ani nectu.
#ifndef dedicated_server
 while (cinfo.output_scanline<cinfo.output_height) { //nacte scanlines
  b=buffer->data+(y-1-num_scanlines)*x*bpp;
  ns=jpeg_read_scanlines(&cinfo,&b,1);
  num_scanlines+=ns;
 }
#endif
 jpeg_finish_decompress(&cinfo);
 }//final return of error handler (setjmp)
final:
 *out=buffer;
 jpeg_destroy_decompress(&cinfo);
 free(in);
 if (buffer) return x*y*bpp+sizeof(tgaheader);
 return 0;
}

/** Targy jsou v BGR misto RGB ... tohle je zkonvertuje do spravneho formatu*/
void fs_rgbfix(tgafile *t) {
#ifndef dedicated_server
 int i=0;
 unsigned char q;
 int size=(t->head.x)*(t->head.y)*(t->head.bpp/8);
 for (i=0;i<size;i+=t->head.bpp/8) {
  q=t->data[i];
  t->data[i]=t->data[i+2];
  t->data[i+2]=q;
 }
#endif
}

/** Spravi transparenci u textur. Pokud je vsude 0, tak ji nastavi vsude na 255*/
void fs_alphafix(tgafile *t) {
#ifndef dedicated_server
 int i,size;
 uint *p;
 if (t->head.bpp!=32) return;
 size=(t->head.x)*(t->head.y);
 p=(uint *)t->data;
 for (i=0;i<size;i++) {
  if (p[i] & 0xff000000) return;
 }
 for (i=0;i<size;i++) {
  p[i]|=0xff000000;
 }
#endif
}


/** nahraje tga texturu
 vrati velikost v bajtech vc. hlavicky a pokud neuspeje, vrati 0 a out je nastaven na NULL */
int fs_loadtgafile(void **ou,const char *name) {
 int q=fs_loadfile(ou,name);
 if (q<sizeof(tgaheader)) { //neni to TGA, takze nic ...
  if(q && ou) free(*ou);
  *ou=NULL;
  return q;
 }
 if (q<(int)(((tgaheader*)*ou)->x*((tgaheader*)*ou)->y*(((tgaheader*)*ou)->bpp/8)+sizeof(tgaheader))) {
  //je to zakomprimovany, ci co ... zamitnout!
  debug_printf("todo: zakompreseny textury neumim (%s)!",name);
  if(q && ou) free(*ou);
  *ou=NULL;
  return q;
 }
 //todo: zvladat kompresovane a 8bpp targy
 if (*ou) fs_rgbfix(*ou);
 if (*ou) fs_alphafix(*ou);
 return q;
}

/** vyrobi "defaultni" hnusnou texturu, ktera je pouzita kdyz textura chybi/nelze nahrat
 Je to tam aby to kvuli tomu nesletelo, ale textura je tak hnusna, ze toho ze tam chybi
 si asi kazdy hned vsimne */
void fs_failsafe_texture(texture *tex) {
 int i,j;
 tgafile *t;
 //debug_printf("making failsafe texture\n");
 if (tex->mem) return;//textura jiz existuje - nic se nedeje
 t=malloc0(16*16*3+sizeof(tgaheader));
 tex->mem=t;
 tex->id=0;
 tex->refcount=1;
 t->head.x=16;
 t->head.y=16;
 t->head.bpp=3*8;
 for(i=0;i<16;i++) for(j=0;j<16;j++) {
  t->data[(i*16+j)*3]=((i==0)||(i==15))*255;
  t->data[(i*16+j)*3+1]=((j==0)||(j==15))*255;
  t->data[(i*16+j)*3+2]=((i+j)&1)*255;
 }
 //debug_printf("made failsafe texture\n");
}

/** Nahraje texturu. Nejdriv zkusi .tga, potom .jpg */
void fs_loadtexture(texture *ou,const char *name) {
 char tex[257];
 tex[257]=0;
 //TODO: zvladat i 16bitove a 8bitove targy
 if (!failsafetex) failsafetex=malloc0(sizeof(texture));
 if (!failsafetex->mem) {// vyrobi defaultni hnusnou texturu
  fs_failsafe_texture(failsafetex);
 }
 _snprintf(tex,sizeof(tex)-1,"%s/%s.tga",texdir,name);
#ifndef dedicated_server
 (void)fs_loadtgafile(&ou->mem,tex);//try tga
 if (!ou->mem) {//tga not present, try jpg
  _snprintf(tex,sizeof(tex)-1,"%s/%s.jpg",texdir,name);
  (void)fs_loadjpegfile(&ou->mem,tex);//try jpeg
 }
#endif
 ou->name=strdup(name);
 if (!ou->mem) {//return default ugly texture
  debug_printf("%s cannot be loaded, used failsafe\n",name);
  ou->mem=failsafetex->mem;
 }
 #ifndef only_console //commandline utilites nepouzivaji opengl
  glGenTextures(1,&ou->id);
  gl_loadtgatex(ou->id,ou->mem);
 #endif
}

/** Uvolni nahranou texturu z pameti */
void fs_unloadtexture(texture *ou) {
 if (ou->mem!=failsafetex->mem) free(ou->mem);// z failsafe se bere vzdy jen odkaz na pamet.
 #ifndef only_console //commandline utilites nepouzivaji opengl
 glDeleteTextures(1,&ou->id);//smazat textury z graficke karty
 #endif
 free(ou->name);
 free(ou);
}

/**  nahraje texturu s danym jmenem a zaradi ji do seznamu nahranych texturv "texture manageru"
  Pokud je v pameti tak misto nahravani rovnou vrati pointer.
*/
texture *b_loadtexture(char *name) {
 texture *tg;
 tg=tree_search(tex_tree,name);
 if (tg) return tg; //textura je jiz v pameti, netreba nahravat
 tg=malloc0(sizeof(texture));
 fs_loadtexture(tg,name);
 if (tg->mem) {
  debug_printf0("[TexMan] %s loaded\n",name);
  tree_add(&tex_tree,name,tg);
  tex_memory+=tex_bytes(tg);
  return tg;
 } else {
  fatalf("SHOULD NOT BE HERE: [TexMan] %s unavailable, failsafe may be used\n",name);
  tree_add(&tex_tree,name,&failsafetex);// textura neni, da se misto ni tak obludnost
  free(tg);
  return failsafetex;
 }
}

/**  podiva se po texture s danym jmenem v pameti "texture manageru" a pokud tam je, tak ji
natvrdo odstrani (nezkouma jestli se pouziva nebo tak nejak)*/
void b_unloadtexture(char *name) {
 texture *tg=tree_search(tex_tree,name);
 if (!tg) return; //textura jiz neni v pameti
 tree_del(&tex_tree,name);
 tex_memory-=tex_bytes(tg);
 fs_unloadtexture(tg);
}

/** zavola b_loadtexture a zvysi usage counter u textury
*/
texture *b_loadtexture_r(char *name) {
 texture *r=b_loadtexture(name);
 if (r) r->refcount++;
 return r;
}

/**  podiva se po texture s danym jmenem v pameti "texture manageru" a pokud tam je, tak ji snizi reference count. Pokud je 0, tak je textura odstranena z pameti */
void b_unloadtexture_r(char *name) {
 texture *tg=tree_search(tex_tree,name);
 debug_printf("texture %s:\n",name);
 if (!tg) return; //textura jiz neni v pameti
 debug_printf("..found, and unreferenced (%d)\n",tg->refcount);
 tg->refcount--;
 if (tg->refcount) return;// stale je pouzivana
 //TODO: pokud je FAKT hodne pameti, tak by to tu mohlo zustat az do dalsiho tex_flush
 debug_printf("..removed (%d)\n",tg->refcount);
 tree_del(&tex_tree,name);
 tex_memory-=tex_bytes(tg);
 fs_unloadtexture(tg);
}

/** prida texturu do texturelistu */
void tex_list_addtexture(tex_list **m,texture *tex) {
 tex_list *t=*m;
 while (t) {
  if (t->t==tex) return; //textura tam jiz je
  t=t->next;
 }
 if (!t) {//zadne textury -> pridat
  t=*m;
  *m=malloc0(sizeof(tex_list));
  (*m)->t=tex;
  (*m)->next=t;
 }
}

/** vnitri callback funkce tex_flush (pridani textury do seznamu) */
void _tex_flush(char *name,texture *t,tex_list **l) {
 if (t->refcount) return;
 tex_list_addtexture(l,t);
 unused(name);
}


/** odstrani z pameti textury co nejsou pouzivany (refcount=0) */
void tex_flush() {
 tex_list *t=0,*p;
 tree_foreach_p(tex_tree,_tex_flush,&t);//nalezeni vsech nepouzitych textur a pridani do seznamu
 p=t;
 while(p) {//likvidace obsahu seznamu
  debug_printf0("removing %s:%d\n",p->t->name,p->t->refcount);
  b_unloadtexture(p->t->name);
  p=p->next;
 }
 freetexlist(t);//likvidace seznamu
}

/** odalokuje v pameti texture list */
void freetexlist(tex_list *t) {
 tex_list *q;
 while (t) {
  q=t->next;
  debug_printf0("freetexlist: %s %d\n",t->t->name,t->t->refcount);
  free(t);
  debug_printf0("freetexlist: ok\n");
  t=q;
 }
}

char *current_skymap;          //jmeno aktualniho skyboxu [EXT]
char *skybox_fmt[]={"sky/%sft","sky/%srt","sky/%sbk","sky/%slf","sky/%sup","sky/%sdn"};//format ve kterem jsou soubory

/**  nahraje skymapu z 6 textur xzacinajicich danym prefixem (basename)*/
void fs_loadskymap(const char *basename) {
 int i;
 char tx[256];
 debug_printf("loading skybox %s\n",basename);
#ifndef dedicated_server
 if (current_skymap) { //nejaka skymapa uz je v pameti
  if (!stricmp(basename,current_skymap)) {
   debug_printf("no loading, already have it\n");
   return;
  }
  debug_printf("freeing previous skybox\n");
  for (i=0;i<6;i++) { //zlikvidovat starou skymapu nebo vytvorit prazdnou
   _snprintf(tx,sizeof(tx),skybox_fmt[i],current_skymap);
   b_unloadtexture_r(tx);//skyboxy zerou tolik pameti, ze je lepsi je jich zbavit hned
  }
  free(current_skymap);
 }
 if (!basename || !*basename) {
  debug_printf("No new skybox loaded\n");
  current_skymap=0;
  for (i=0;i<6;i++) tex_skybox[i]=0;//pro jistotu
  return;
 }
 current_skymap=strdup(basename);
 for (i=0;i<6;i++) {
  _snprintf(tx,sizeof(tx),skybox_fmt[i],basename);
  tex_skybox[i]=b_loadtexture_r(tx);
  debug_printf0("load skybox: %d (%d)\n",i,tex_skybox[i]->mem);
 }
#endif
}
@


1.5
log
@*** empty log message ***
@
text
@d5 1
d15 1
d25 1
d30 1
d33 1
d130 1
d136 1
d149 1
d158 1
d163 1
d175 1
d234 1
d240 1
d373 1
d398 1
@


1.4
log
@*** empty log message ***
@
text
@a189 2
#ifndef image_utils //[PASS]

d352 33
a384 1
#endif //[PASS]
@


1.3
log
@*** empty log message ***
@
text
@d200 1
a200 1
 t=malloc0(16*16*+sizeof(tgaheader));
@


1.2
log
@*** empty log message ***
@
text
@d190 2
d353 2
@


1.1
log
@Initial revision
@
text
@d15 1
@
