#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
#include "b_mem.h"
#include "b_string.h"

#define datadir "data" // adresar s daty
#define default_config_file "config.cfg" //defaultni soubor s konfiguraci
#define default_alias_file "alias.cfg" //defaultni soubor s aliasy

// makro na kontrolu jestli cesta neobsahuje neco divneho
// (treba con\con)
//. v pripade ze ano, tak to haltne program nebo vrati error + return
#define security_check // prazdne makro, cili je to zatim vypnuto

// Na windows a linuxu jsou jine oddelovace cesty
#ifdef WIN32
#define fs '\\'		//nativni filesystem separator
#define fs2 '/'		//alternativni filesystem separator
#else
#define fs '/'		//nativni filesystem separator
#define fs2 '\\'	//alternativni filesystem separator
#endif

#define FILEBUF_LEN (32*1024) //size of file output buffer

typedef struct { //buffered file output
 FILE *f;		//file
 int bytes;		//bytes in buffer
 char buf[FILEBUF_LEN];	//buffer
} filebuffer;

