#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
#include "b_math.h"
#include "b_util.h"
#include "b_mem.h"
#include "b_string.h"
#include "b_con.h"
#include "b_ai.h"
#include "b_coll.h"
#include "b_model3d.h"
#include "b_sound.h"
#include "b_menu.h"
#include "b_gl.h"

#define default_screens_max 16;//defaultni maximalni pocet obrazovak. Lze ve hre realokovat na vyssi pocet

#define mintick 0.001 //nejkratsi doba mezi framy v sekundach (Max 1000 FPS)
#define maxtick 0.2   //nejdelsi doba mezi framy v sekundach (Min 5 FPS)

#define world_foreach_obj(w,i) for ((i)=0;(i)<(w)->obj.numobj;(i)++)
#define world_getobj(w,n) ((w)->obj.obj[n]) //odkaz na nty objekt
#define world_lastobj(w) (world_getobj((w),(w)->obj.numobj)) //odkaz na posledni objekt ve worldspawnu

#define bug_report(x) con_printf(x " in %s: %s = %s",oc->classname,key,value);//bugreport makro pro parse_classdef()

#define object_getprop(o,name) getprop((o)->prop,name)//z objektu ziska jeho vlastnost jako string

