/*** ruzne veci co se nevesly jinam + sprava pameti (jednoducha) */

#ifndef _bilbo_h_
#define _bilbo_h_
#ifdef _WIN32
//par veci na optimalizaci MSVC6
#pragma optimize("gty",on)
#pragma comment(linker,"/RELEASE")
#pragma comment(linker,"/merge:.rdata=.data")
#pragma comment(linker,"/merge:.text=.data")
#pragma comment(linker,"/merge:.reloc=.data")
#endif
#define unused(x) (x)      //na likvidaci varovani "parameter not used"

#ifdef _WIN32
#ifndef WIN32
 #define WIN32
#endif
#define win32
#endif

#pragma warning(push,1) //vypnout varovani o chybach v systemovych headerech ...
#pragma warning(disable: 4142)
#ifdef WIN32
 #include <io.h>
 #include <direct.h>
#else
 #include <stdarg.h>
#endif
#ifdef WIN32
 #include <windows.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <GL/gl.h>
#include "b_glext.h"
#include <GL/glu.h>
#include <GL/glut.h>
#include <unzip.h>           
#include <float.h>           
#ifdef WIN32
 #include <jinclude.h>
#endif
#include <setjmp.h>
#include <jpeglib.h>

#include <time.h>
#include <math.h>
#include <sys/stat.h>
#include <limits.h>
#pragma warning(pop) 
#pragma warning(disable:4514) //unreferenced inline function has been removed
#pragma warning(disable:4244) //conversion from X to Y, possible loss of data
#pragma warning(disable:4305) //'initializing' : truncation from X to Y
#define pi 3.1415926535897932386426433	//konstanta pi

#ifndef _MSC_VER
//linux/GNUC
#define cdecl __cdecl           //definice volani C-konvenci
#define cdecl_void void         //definice volani C-konvenci s navratem void
#define cdecl_int int           //definice volani C-konvenci s navratem void
#else
//windows/MSVC
#define cdecl_void cdecl void   //definice volani C-konvenci s navratem void
#define cdecl_int cdecl int   //definice volani C-konvenci s navratem void
#endif

#ifdef WIN32
typedef __int64 int64;          //64bitovy integer
#else
//typedef long long int64;//TODO: tohle nefunguje, nevim proc. Nastesti to nepotrebuju
#endif
#ifndef WIN32
#define _gcvt gcvt             //v linuxu je jiny nazev funkce nez ve windows
#define _mkdir(x) mkdir(x,0755) //v linuxu je u mkdir jeste potreba dodat permissions
#endif

#define true 1   //true
#define false 0  //false

#define unnull(x) ((x)?(x):"") //pokud je x==NULL tak vrati prazdny retezec, jinak x

#define findfirst _findfirst //alias 
#define findnext _findnext //alias 
#define findclose _findclose //alias 
#define getcwd _getcwd //alias 

// Prace s retezci

//pocet prvku pole
#define elements(x) (sizeof(x)/sizeof((x)[0]))
//free and make NULL
#define free0(x) free(x);(x)=0

// true pokud je znak newline (cr nebo lf)
#define newline(x) (((x)==13)||((x)==10))
// true pokud je znak whitespace (mezera, tabulator, newline ...)
#define isseparator(x) (((x)==' ')||((x)=='\t')||newline(x))

#define while_(x) while((x)!=0) //obycejny while, jenom nehazi varovani "assignment within conditional expression"
#define if_(x) if((x)!=0) //obycejny if, jenom nehazi varovani "assignment within conditional expression"

#endif //_bilbo_h_
