#!/usr/bin/perl

use POSIX qw(strftime);
use strict;

sub save {
 my ($s,$name)=@_;
 open(D, ">".$name) || return 0;
 print D $s;
 close D ||return 0;
 return 1;
}

sub load {
 my ($name)=@_;
 open(D, "<".$name) || return '';
 my $s;
 read D,$s,999999;
 close D || return '';
 return $s;
}

$_=load("build.h");
if (/\#define\s+BUILDNUMBER\s+\"(\d+)\"(\/\/.*)?[\r\n]*/) {
 $b=$1+1;
 $_="#define BUILDNUMBER \"$b\" //Current build number\n";
 my $d=strftime "%d.%m.%Y %H:%M:%S", localtime;
 $_.="#define BUILDTIME \"$d\" //Date of current build";

 save($_,"build.h");
} else {
 print $_;
}
